package Gui;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import fahrzeug.*;
import kunde.*;
import java.util.Vector;


/**
 * Diese Klasse zeigt die vorhandene Fahrzeuge nach gewhlten Kategorien und Klassen
 * 
 * @author Nathalie
 */
public class AlleFahrzeuge extends javax.swing.JFrame
{
  
 public AlleFahrzeuge()
 {
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setSize(525,355);
		setVisible(false);
		FahrzeugListPanel.setLayout(null);
		getContentPane().add(FahrzeugListPanel);
		FahrzeugListPanel.setBackground(java.awt.Color.white);
		FahrzeugListPanel.setBounds(0,0,525,288);
		AutoInfoScroll.setOpaque(true);
		FahrzeugListPanel.add(AutoInfoScroll);
		AutoInfoScroll.setBounds(0,0,312,288);
		AutoInfoScroll.getViewport().add(AutoInfoTextArea);
		AutoInfoTextArea.setBounds(0,0,309,285);
		AutoInfoTextArea.setEditable(false);
		FahrzeugListPanel.add(BildAuto);
		BildAuto.setBounds(312,132,216,156);
		BildAuto.setBackground(Color.white);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,288,525,57);
		PrevButton.setText("<");
		PrevButton.setActionCommand("<");
		PrevButton.setEnabled(false);
		NavPanel.add(PrevButton);
		PrevButton.setBounds(288,12,73,25);
		WeiterButton.setText(">");
		WeiterButton.setActionCommand(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(372,12,73,25);
		SeiteTextField.setDisabledTextColor(java.awt.Color.gray);
		NavPanel.add(SeiteTextField);
		SeiteTextField.setBackground(new java.awt.Color(226,228,241));
		SeiteTextField.setBounds(456,12,58,28);
		exitButton.setText("Ende");
		NavPanel.add(exitButton);
		exitButton.setBounds(204,12,76,24);
		SeiteTextField.setEditable(false);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		PrevButton.addActionListener(lSymAction);
		WeiterButton.addActionListener(lSymAction);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		exitButton.addActionListener(lSymAction);
		//}}
	}
	
public AlleFahrzeuge(Vector fzgList,String fzkategorie,String fzklasse)
 {
  this();
  fzgListe = fzgList;
  fzgListeSize = fzgListe.size();
  FahrzeugHeader= "Kategorie: "+fzkategorie+" \n"+"Klasse: "+fzklasse+" \n"; 
  zeigeAutoInformation();
  
 }
	
	
	//{{DECLARE_CONTROLS
	javax.swing.JPanel FahrzeugListPanel = new javax.swing.JPanel();
	javax.swing.JScrollPane AutoInfoScroll = new javax.swing.JScrollPane();
	javax.swing.JTextArea AutoInfoTextArea = new javax.swing.JTextArea();
	javax.swing.JLabel BildAuto = new javax.swing.JLabel();
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton PrevButton = new javax.swing.JButton();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JTextField SeiteTextField = new javax.swing.JTextField();
	javax.swing.JButton exitButton = new javax.swing.JButton();
	//}}
	//{{DECLARE_MENUS
	//}}

	//{{additional properties
	Vector fzgListe;
	String FahrzeuginfoOutput = new String();
	String FahrzeugHeader = new String();
	int listPositionCounter =0;
	int fzgListeSize;
	//}}
	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == PrevButton)
				PrevButton_actionPerformed(event);
			else if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
			else if (object == exitButton)
				exitButton_actionPerformed(event);
		}
	}

	void PrevButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		PrevButton_actionPerformed_Interaction1(event);
			 
		PrevButton_actionPerformed_Interaction2(event);
	}

	void PrevButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		if(listPositionCounter > 0)
		 {
		  listPositionCounter--; 
	      zeigeAutoInformation();
	     }
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		WeiterButton_actionPerformed_Interaction1(event);
			 
		WeiterButton_actionPerformed_Interaction2(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		if(listPositionCounter < fzgListeSize-1)
		 {
		  listPositionCounter++; 
	      zeigeAutoInformation();
	     }
	}

	void PrevButton_actionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		if(listPositionCounter == 0)
		 {
		  try {
			WeiterButton.setEnabled(true);
		    PrevButton.setEnabled(false);
		  } catch (java.lang.Exception e) {
		  }
		 }
		 else
		 {
		  WeiterButton.setEnabled(true);
		  PrevButton.setEnabled(true);
		  }
	}

	void WeiterButton_actionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		if(listPositionCounter == fzgListeSize-1)
		 {
		  try {
			WeiterButton.setEnabled(false);
		    PrevButton.setEnabled(true);
		  } catch (java.lang.Exception e) {
		  }
		 }
		 else
		 {
		  WeiterButton.setEnabled(true);
		  PrevButton.setEnabled(true);
		  }
	}

   //{{additional methods

   /**
    * Gibt die Angebotinformation aus
    */
   public void zeigeAutoInformation()
   {
     Fahrzeug tmpFzg = (Fahrzeug)fzgListe.elementAt(listPositionCounter);
     FahrzeuginfoOutput = FahrzeugHeader+ " \n Wochenpreis: \u20AC"+ String.valueOf(tmpFzg.holeWochenpreis()); 
     AutoInfoTextArea.setText(FahrzeuginfoOutput);  
     String tmpAbbildung = tmpFzg.holeImage();
     BildAuto.setIcon(new ImageIcon(tmpAbbildung));
     SeiteTextField.setText(listPositionCounter+"/"+String.valueOf(fzgListe.size()-1));
    }
   
   //}}
  

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == AlleFahrzeuge.this)
				AlleFahrzeuge_windowClosing(event);
		}
	}

	void AlleFahrzeuge_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		AlleFahrzeuge_windowClosing_Interaction1(event);
	}

	void AlleFahrzeuge_windowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			this.setVisible(false);
			dispose();
		} catch (java.lang.Exception e) {
		}
	}

	void exitButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		exitButton_actionPerformed_Interaction1(event);
	}

	void exitButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			this.dispose();
		} catch (java.lang.Exception e) {
		}
	}
}
