package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import fahrzeug.*;
import kunde.*;

/**
 * Benutzerschnittstelle zum Eingeben von gewnschten Fahrzeugeigenschaften, Mietdatum und Kundentyp
 *
 * @author Nathalie
 */
public class AngebotFormular extends javax.swing.JFrame
{

    public AngebotFormular( Kundenanfrage zurueckZuKunde,String Kategorie,String Klasse)
    {
     this();
     zuKundenAnfrage =  zurueckZuKunde;
     if(Kategorie.equals("PKW"))
        KategorieCombo.setSelectedIndex(0);
     else
        if(Kategorie.equals("LKW"))
           KategorieCombo.setSelectedIndex(1);
        else
           KategorieCombo.setSelectedIndex(2);
     KlasseKombo.setSelectedItem(Klasse);

     }

    public AngebotFormular() {
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setSize(640,480);
		setVisible(false);
		FormularPanel.setLayout(null);
		getContentPane().add(FormularPanel);
		FormularPanel.setBackground(java.awt.Color.white);
		FormularPanel.setBounds(0,0,640,400);
		KatKlassePanel.setBorder(KatKlasseBorder);
		KatKlassePanel.setLayout(new GridLayout(1,1,0,0));
		FormularPanel.add(KatKlassePanel);
		KatKlassePanel.setBackground(new java.awt.Color(226,228,241));
		KatKlassePanel.setBounds(24,36,576,55);
		KatKlassePanel.add(KategorieCombo);
		KategorieCombo.setBounds(5,20,283,30);
		KatKlassePanel.add(KlasseKombo);
		KlasseKombo.setBounds(288,20,283,30);
		TerminPanel.setBorder(TerminBorder);
		TerminPanel.setLayout(null);
		FormularPanel.add(TerminPanel);
		TerminPanel.setBackground(new java.awt.Color(226,228,241));
		TerminPanel.setBounds(324,96,276,168);
		MietstartLabel.setText("Von");
		TerminPanel.add(MietstartLabel);
		MietstartLabel.setBounds(12,12,115,20);
		TerminPanel.add(StartTagTextField);
		StartTagTextField.setBounds(12,60,44,20);
		TerminPanel.add(StartMonatTextField);
		StartMonatTextField.setBounds(72,60,44,20);
		TerminPanel.add(StartJahrTextField);
		StartJahrTextField.setBounds(132,60,60,20);
		StartTagLabel.setText("Tag");
		TerminPanel.add(StartTagLabel);
		StartTagLabel.setBounds(12,36,51,19);
		StartMonatLabel.setText("Monat");
		TerminPanel.add(StartMonatLabel);
		StartMonatLabel.setBounds(72,36,51,19);
		StartJahrLabel.setText("Jahr");
		TerminPanel.add(StartJahrLabel);
		StartJahrLabel.setBounds(132,36,51,19);
		RueckgabeLabel.setText("Rckgabe");
		TerminPanel.add(RueckgabeLabel);
		RueckgabeLabel.setBounds(12,84,96,24);
		EndTagLabel.setText("Tag");
		TerminPanel.add(EndTagLabel);
		EndTagLabel.setBounds(12,108,51,19);
		EndJahrLabel.setText("Jahr");
		TerminPanel.add(EndJahrLabel);
		EndJahrLabel.setBounds(132,108,51,19);
		EndMonatLabel.setText("Monat");
		TerminPanel.add(EndMonatLabel);
		EndMonatLabel.setBounds(72,108,51,19);
		TerminPanel.add(EndTagTextField);
		EndTagTextField.setBounds(12,132,44,20);
		TerminPanel.add(EndMonatTextField);
		EndMonatTextField.setBounds(72,132,44,20);
		TerminPanel.add(EndJahrTextField);
		EndJahrTextField.setBounds(132,132,60,20);
		FirmenPanel.setBorder(FirmenBorder);
		FirmenPanel.setLayout(null);
		FormularPanel.add(FirmenPanel);
		FirmenPanel.setBackground(new java.awt.Color(226,228,241));
		FirmenPanel.setBounds(24,276,576,120);
		FirmenkundeCheck.setText("Firmenkunde");
		FirmenkundeCheck.setActionCommand("Firmenkunde");
		FirmenPanel.add(FirmenkundeCheck);
		FirmenkundeCheck.setBackground(new java.awt.Color(226,228,241));
		FirmenkundeCheck.setBounds(12,24,144,24);
		FirmennummerLabel.setText("Firmenkundennummer");
		FirmenPanel.add(FirmennummerLabel);
		FirmennummerLabel.setForeground(new java.awt.Color(128,128,192));
		FirmennummerLabel.setBounds(12,60,156,12);
		KundennummerTextfield.setEditable(false);
		FirmenPanel.add(KundennummerTextfield);
		KundennummerTextfield.setBounds(12,84,480,22);
		NavigationPanel.setBorder(lineBorder1);
		NavigationPanel.setLayout(null);
		getContentPane().add(NavigationPanel);
		NavigationPanel.setBackground(new java.awt.Color(226,228,241));
		NavigationPanel.setBounds(0,400,640,80);
		WeiterButton.setText(">");
		WeiterButton.setActionCommand(">");
		NavigationPanel.add(WeiterButton);
		WeiterButton.setBounds(564,20,62,29);

		for(int i=0; i < Kategorien.length; i++)
		{
		 KategorieCombo.addItem(Kategorien[i]);
		}

		for(int k=0; k< PKWKlassen.length ; k++)
		{
		 KlasseKombo.addItem(PKWKlassen[k]);
		}

		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		FirmenkundeCheck.addItemListener(lSymItem);
		KategorieCombo.addItemListener(lSymItem);
		KlasseKombo.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
		//}}
	}

	//{{DECLARE_CONTROLS
	javax.swing.JPanel FormularPanel = new javax.swing.JPanel();
	javax.swing.JPanel KatKlassePanel = new javax.swing.JPanel();
	javax.swing.JComboBox KategorieCombo = new javax.swing.JComboBox();
	javax.swing.JComboBox KlasseKombo = new javax.swing.JComboBox();
	javax.swing.JPanel TerminPanel = new javax.swing.JPanel();
	javax.swing.JLabel MietstartLabel = new javax.swing.JLabel();
	javax.swing.JTextField StartTagTextField = new javax.swing.JTextField();
	javax.swing.JTextField StartMonatTextField = new javax.swing.JTextField();
	javax.swing.JTextField StartJahrTextField = new javax.swing.JTextField();
	javax.swing.JLabel StartTagLabel = new javax.swing.JLabel();
	javax.swing.JLabel StartMonatLabel = new javax.swing.JLabel();
	javax.swing.JLabel StartJahrLabel = new javax.swing.JLabel();
	javax.swing.JLabel RueckgabeLabel = new javax.swing.JLabel();
	javax.swing.JLabel EndTagLabel = new javax.swing.JLabel();
	javax.swing.JLabel EndJahrLabel = new javax.swing.JLabel();
	javax.swing.JLabel EndMonatLabel = new javax.swing.JLabel();
	javax.swing.JTextField EndTagTextField = new javax.swing.JTextField();
	javax.swing.JTextField EndMonatTextField = new javax.swing.JTextField();
	javax.swing.JTextField EndJahrTextField = new javax.swing.JTextField();
	javax.swing.JPanel FirmenPanel = new javax.swing.JPanel();
	javax.swing.JCheckBox FirmenkundeCheck = new javax.swing.JCheckBox();
	javax.swing.JLabel FirmennummerLabel = new javax.swing.JLabel();
	javax.swing.JTextField KundennummerTextfield = new javax.swing.JTextField();
	javax.swing.JPanel NavigationPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.border.LineBorder lineBorder1 = new javax.swing.border.LineBorder(Color.black);
	//javax.swing.border.TitledBorder SonderBorder = new javax.swing.border.TitledBorder("");
	javax.swing.border.TitledBorder TerminBorder = new javax.swing.border.TitledBorder("Termin");
	javax.swing.border.TitledBorder FirmenBorder = new javax.swing.border.TitledBorder("Firmenkunde");
	javax.swing.border.TitledBorder KatKlasseBorder = new javax.swing.border.TitledBorder("Kategorie und Klasse");
	//}}
	//{{DECLARE_MENUS
	//}}

	//{{additional properties
	Kundenanfrage zuKundenAnfrage;

	Kundenanfrage zurueckAnKunde;
	String[] PKWKlassen = {"Kompaktwagen","Mittelklasse","Oberklasse","Van"};
	String[] LKWKlassen = {">2.8","<2.8"};
	String[] PickUpKlassen = {"-"};
	String[] Kategorien = {"PKW","LKW","PickUp"};
	//}}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == FirmenkundeCheck)
				FirmenkundeCheck_itemStateChanged(event);
			else if (object == KategorieCombo)
				KategorieCombo_itemStateChanged(event);
			else if (object == KlasseKombo)
				KlasseKombo_itemStateChanged(event);


		}
	}

	void FirmenkundeCheck_itemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.

		FirmenkundeCheck_itemStateChanged_Interaction1(event);
	}

	void FirmenkundeCheck_itemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			// FirmenkundeCheck Is the JCheckBox checked
			KundennummerTextfield.setEditable(FirmenkundeCheck.isSelected());
			if(!FirmenkundeCheck.isSelected())
			   KundennummerTextfield.setText(null);
		} catch (java.lang.Exception e) {
		}
	}

	void KategorieCombo_itemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.

		KategorieCombo_itemStateChanged_Interaction1(event);
	}

	void KategorieCombo_itemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		//change the item list to correspond to the vehicle category
		 //Update der Liste in der Klassenkombo und speichern der gewhlten Kategorie
	 if(((String)KategorieCombo.getSelectedItem()).equals("PKW"))
	  {
	   KlasseKombo.removeAllItems();
	   for(int k=0; k< PKWKlassen.length ; k++)
		{
		 KlasseKombo.addItem(PKWKlassen[k]);
		}
	  }
	 else
	   if(((String)KategorieCombo.getSelectedItem()).equals("LKW"))
	    {
	      KlasseKombo.removeAllItems();
	      for(int l=0; l< LKWKlassen.length ; l++)
		  {
		   KlasseKombo.addItem(LKWKlassen[l]);
		   }
	     }
	    else
	      {//PickUp
	        KlasseKombo.removeAllItems();
	        KlasseKombo.addItem(PickUpKlassen[0]);
	       }
	  KlasseKombo.invalidate();
	}

	void KlasseKombo_itemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.

		KlasseKombo_itemStateChanged_Interaction1(event);
	}

	void KlasseKombo_itemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			FormularPanel.setVisible(true);
		} catch (java.lang.Exception e) {
		}
	}



	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
		}
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try{
		zuKundenAnfrage.setzeSonderwuensche(true); //August 2001 andere Sonderwuensche wurden geloescht wie z.b. "raucher, automatic,anzahl der Sitze"
		zuKundenAnfrage.sonderWuenscheKatKlasse((String)KategorieCombo.getSelectedItem(),(String) KlasseKombo.getSelectedItem());
	    }
	    catch(java.lang.NumberFormatException e)
	    {
	     (new GeneralDialog(this,"Korrigieren Sie Ihre Eingabe")).setVisible(true);
	     zuKundenAnfrage.setzeSonderwuensche(true);
		 zuKundenAnfrage.sonderWuenscheKatKlasse((String)KategorieCombo.getSelectedItem(),(String) KlasseKombo.getSelectedItem());
	    }
	    try{
	    int tmpStart[]={Integer.parseInt(StartJahrTextField.getText()),Integer.parseInt(StartMonatTextField.getText()),Integer.parseInt(StartTagTextField.getText()),0};
	    int tmpEnde[]={Integer.parseInt(EndJahrTextField.getText()),Integer.parseInt(EndMonatTextField.getText()),Integer.parseInt(EndTagTextField.getText()),0};

	    //zahlen gueltigkeit ueberpruefen
	    if((tmpStart[1]>12)||(tmpStart[1]<1)||(tmpStart[2]>31)||(tmpStart[2]<1)||(tmpEnde[1]>12)||(tmpEnde[1]<1)||(tmpEnde[2]>31)||(tmpEnde[2]<1))
	      {
	        (new GeneralDialog(this,"Bitte ein Wert von 1 bis 31 fr Tag und ein Wert von 1 bis 12 fr Monat eingeben")).setVisible(true);
	        return;
	      }

	    //nur 4 stellge jahr ist erlaubt
	    if((tmpStart[0]<2000) || (tmpEnde[0] < 2000))
	      {
	        (new GeneralDialog(this,"Jahresangabe muss vierstellig sein und grer als 1999")).setVisible(true);
	        return;
	      }


	    //{{Datumeingabe ueberpruefen
	    java.util.GregorianCalendar tmpStartCal = new java.util.GregorianCalendar(tmpStart[0],tmpStart[1],tmpStart[2]);
	    java.util.GregorianCalendar tmpEndCal = new java.util.GregorianCalendar(tmpEnde[0],tmpEnde[1],tmpEnde[2]);
	    if(tmpStartCal.getTime().after(tmpEndCal.getTime()))
	      {
	        (new GeneralDialog(this,"Mietbeginn liegt spter als das Rckgabedatum")).setVisible(true);
	        return;
	      }
	    //}}
	    zuKundenAnfrage.terminEingabe(tmpStart, tmpEnde);
	    }
	    catch(java.lang.NumberFormatException e)
	    {
	     (new GeneralDialog(this,"Nur ganze Zahl fr Datum eingeben")).setVisible(true);
	     return;
	     }

	    if(FirmenkundeCheck.isSelected())
	      {
	        try{
	        zuKundenAnfrage.kundennummerEingabe(true, Integer.parseInt(KundennummerTextfield.getText()));
	        }
	        catch(java.lang.NumberFormatException e)
	        {
	        (new GeneralDialog(this,"Bitte geben Sie die Kundennummer ein")).setVisible(true);
	        return;
	        }
    	  }
	    else
	      {
	       zuKundenAnfrage.kundennummerEingabe(false,0);
	      }
	   if(zuKundenAnfrage.holeErzeugteAngebot() != null)
	    {
	      this.setVisible(false);
	      this.dispose();
	    }
	   else
	     return;
	}
}
