package Gui;

import java.awt.*;
import javax.swing.*;
import fahrzeug.*;
/**
 * Dialog, um wirklich sicher zu gehen, da die Fhrerschein tatschlich nicht vorhanden ist.
 * @author Nathalie
 */


public class ConfirmDialog extends javax.swing.JDialog
{
	public ConfirmDialog(Frame parentFrame,String komentar)
	{
		super(parentFrame);
		
		//{{INIT_CONTROLS
		setTitle("Kommentar");
		setModal(true);
		dialogOwner = parentFrame;
		getContentPane().setLayout(new BorderLayout());
		getContentPane().setBackground(java.awt.Color.white);
		setSize(250,100);
		setVisible(false);
		getContentPane().add(buttonsPanel, "South");
		buttonsPanel.setLayout(new GridLayout(1,2));
		
		okButton.setBackground(new java.awt.Color(226,228,241));
		okButton.setText("Ja");
		okButton.setActionCommand("Ja");
		okButton.setOpaque(false);
		buttonsPanel.add(okButton);
		
		noButton.setBackground(new java.awt.Color(226,228,241));
		noButton.setText("Nein");
		noButton.setActionCommand("No");
		noButton.setOpaque(false);
		buttonsPanel.add(noButton);
		
		aboutLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		aboutLabel.setText(komentar);
		getContentPane().add(aboutLabel, "Center");
		
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		noButton.addActionListener(lSymAction);
		
		//}}
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = (getParent()).getBounds();
    		Dimension size = getSize();
    		setLocation(bounds.x + (bounds.width - size.width)/2,
    			        bounds.y + (bounds.height - size.height)/2);
	    }

		super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JButton okButton = new javax.swing.JButton();
	javax.swing.JButton noButton = new javax.swing.JButton();
	javax.swing.JPanel buttonsPanel = new javax.swing.JPanel();
	javax.swing.JLabel aboutLabel = new javax.swing.JLabel();
	Frame dialogOwner ;
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == ConfirmDialog.this)
				jAboutDialog_windowClosing(event);
		}
	}

	void jAboutDialog_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		jAboutDialog_windowClosing_Interaction1(event);
	}

	void jAboutDialog_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			// JAboutDialog Hide the JAboutDialog
			this.setVisible(false);
		} catch (Exception e) {
		}
	}
	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_actionPerformed(event);
		    else 
		     if(object == noButton)
		        noButton_actionPerformed(event);
		 }
	}

	void okButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		okButton_actionPerformed_Interaction1(event);
	}

	void okButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		((MietvertragGui)dialogOwner).setDriverLic(true);	 
		try {
			// JAboutDialog Hide the JAboutDialog
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

  void noButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		noButton_actionPerformed_Interaction1(event);
	}

	void noButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		((MietvertragGui)dialogOwner).setDriverLic(false);	 
		try {
			
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

}

