package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import kunde.*;
import java.util.*;

/**
 * Hier werden die persnlichen Daten der einzelnen Firmenfahrer eingegeben 
 * @author Shahriar,Nathalie
 */
public class FirmenFahrerEingabe extends javax.swing.JFrame{
    public FirmenFahrerEingabe(){
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		getContentPane().setBackground(new java.awt.Color(226,228,241));
		setSize(591,320);
		setVisible(false);
		FahrerEingabePanel.setLayout(null);
		getContentPane().add(FahrerEingabePanel);
		FahrerEingabePanel.setBackground(new java.awt.Color(226,228,241));
		FahrerEingabePanel.setBounds(12,12,324,228);
		FahrerEingabePanel.add(AusweisTextField);
		AusweisTextField.setBounds(120,60,192,24);
		FahrerEingabePanel.add(NameTextField);
		NameTextField.setBounds(120,12,192,24);
		FahrerEingabePanel.add(AlterTextField);
		AlterTextField.setBounds(120,108,72,24);
		NameLabel.setText("Name");
		FahrerEingabePanel.add(NameLabel);
		NameLabel.setBounds(12,12,53,15);
		AusweisLabel.setText("Ausweisnummer");
		FahrerEingabePanel.add(AusweisLabel);
		AusweisLabel.setBounds(12,60,97,15);
		AlterLabel.setText("Alter");
		FahrerEingabePanel.add(AlterLabel);
		AlterLabel.setBounds(12,108,27,15);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,252,591,60);
		WeiterButton.setText(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(504,12,73,25);
		FotoEingabePanel.setLayout(null);
		getContentPane().add(FotoEingabePanel);
		FotoEingabePanel.setBackground(new java.awt.Color(226,228,241));
		FotoEingabePanel.setBounds(348,12,228,228);
		FotoEingabePanel.add(FotoButton);
		FotoButton.setBackground(new java.awt.Color(226,228,241));
		FotoButton.setBounds(72,12,143,151);
		FotoLabel.setText("Foto");
		FotoEingabePanel.add(FotoLabel);
		FotoLabel.setBounds(12,12,41,27);
		FotoEingabePanel.add(FotoTextField);
		FotoTextField.setBounds(72,168,146,25);
		ZeigenButton.setText("zeigen");
		FotoEingabePanel.add(ZeigenButton);
		ZeigenButton.setBounds(144,204,76,24);
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
		ZeigenButton.addActionListener(lSymAction);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
	}

	//{{DECLARE_CONTROLS
	javax.swing.JPanel FahrerEingabePanel = new javax.swing.JPanel();
	javax.swing.JTextField AusweisTextField = new javax.swing.JTextField();
	javax.swing.JTextField NameTextField = new javax.swing.JTextField();
	javax.swing.JTextField AlterTextField = new javax.swing.JTextField();
	javax.swing.JLabel NameLabel = new javax.swing.JLabel();
	javax.swing.JLabel AusweisLabel = new javax.swing.JLabel();
	javax.swing.JLabel AlterLabel = new javax.swing.JLabel();
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JPanel FotoEingabePanel = new javax.swing.JPanel();
	javax.swing.JButton FotoButton = new javax.swing.JButton();
	javax.swing.JLabel FotoLabel = new javax.swing.JLabel();
	javax.swing.JTextField FotoTextField = new javax.swing.JTextField();
	javax.swing.JButton ZeigenButton = new javax.swing.JButton();
	//}}
	//{{DECLARE_MENUS
	//}}

   class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
			else if (object == ZeigenButton)
				ZeigenButton_actionPerformed(event);
		}
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
      FirmenMitglieder fmMitglied;
      int iAusweisnummer = 0, iAlter= 0;
      boolean bAngabenRichtig = true;
       
      try{
        iAusweisnummer= (new Integer(this.AusweisTextField.getText())).intValue();
        iAlter        = (new Integer(this.AlterTextField.getText())).intValue();
      }catch(java.lang.Exception e){
        bAngabenRichtig = false;
        FehlerMeldungBox dialog = new FehlerMeldungBox(null,"","Ihre Eingaben sind unvollstndig (alle Felder mssen geeignete Angaben erhalten)!",false);
        dialog.setVisible(true);
      } 
      if (bAngabenRichtig){
         fmMitglied = new FirmenMitglieder(
             this.NameTextField.getText(),
             iAusweisnummer,
             iAlter,
             this.FotoTextField.getText()
         );
         FirmenKundeEingabe.fkFirmenKunde.fahrerZulassen(fmMitglied);
         //Fenster wieder zu!
         this.setVisible(false);
      }      
	}

	void ZeigenButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		ZeigenButton_actionPerformed_Interaction1(event);
	}

	void ZeigenButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			FotoButton.setIcon(new ImageIcon(FotoTextField.getText()));
		
		} catch (java.lang.Exception e) {
		}
	}

  private void jbInit() throws Exception {
  }
}