package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import Starter;
import fahrzeug.*;
import dvtautoio.*;

/**
 * Hier werden die Privatkundendaten eingegeben. 
 * @author Shahriar, Nathalie
 */
public class PrivatKundeEingabe extends javax.swing.JFrame
{
    boolean bKundeBekannt = false;
    public PrivatKundeEingabe(KundenInfoAnReservierung _frs)
    {
     this();
     ZuReservierung = _frs;
     }
     
    public PrivatKundeEingabe() {
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		getContentPane().setBackground(new java.awt.Color(226,228,241));
		setSize(641,393);
		setVisible(false);
		KundendatenEingabePanel.setLayout(null);
		getContentPane().add(KundendatenEingabePanel);
		KundendatenEingabePanel.setBackground(new java.awt.Color(226,228,241));
		KundendatenEingabePanel.setBounds(12,12,600,297);
		KundendatenEingabePanel.add(AusweisTextField);
		AusweisTextField.setBounds(156,160,324,20);
		KundendatenEingabePanel.add(NameTextField);
		NameTextField.setBounds(156,24,324,20);
		KundendatenEingabePanel.add(AlterTextField);
		AlterTextField.setBounds(156,216,60,20);

		KundendatenEingabePanel.add(KundenAddrTextFieldStrasse);
		KundenAddrTextFieldStrasse.setBounds(156,60,324,20);
  		KundendatenEingabePanel.add(KundenAddrTextFieldHausNummer);
		KundenAddrTextFieldHausNummer.setBounds(156,85,324,20);
		KundendatenEingabePanel.add(KundenAddrTextFieldPLZ);
		KundenAddrTextFieldPLZ.setBounds(156,110,324,20);
		AddressLabelStrasse.setText("Strasse");
		KundendatenEingabePanel.add(AddressLabelStrasse);
		AddressLabelHausnummer.setText("Hausnummer");
		KundendatenEingabePanel.add(AddressLabelHausnummer);
		AddressLabelPLZ.setText("PLZ");
		KundendatenEingabePanel.add(AddressLabelPLZ);
		AddressLabelStrasse.setBounds(12,55,115,28);
		AddressLabelHausnummer.setBounds(12,80,115,28);
		AddressLabelPLZ.setBounds(12,105,115,28);
		KartenLabel.setText("Kreditkartennummer");
		KundendatenEingabePanel.add(KartenLabel);
		KartenLabel.setBounds(12,186,120,28);
  		KundendatenEingabePanel.add(KartenTextField);
		KartenTextField.setBounds(156,191,324,20);
		SuchenButton.setText("Suchen");
		SuchenButton.setBounds(482,20,90,25);
		KundendatenEingabePanel.add(SuchenButton);




		NameLabel.setText("Name");
		KundendatenEingabePanel.add(NameLabel);
		NameLabel.setBounds(12,24,115,28);
		AusweisLabel.setText("Ausweisnummer");
		KundendatenEingabePanel.add(AusweisLabel);
		AusweisLabel.setBounds(12,156,115,28);
		AlterLabel.setText("Alter");
		KundendatenEingabePanel.add(AlterLabel);
		AlterLabel.setBounds(12,216,115,28);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,326,540,60);
		WeiterButton.setText(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(456,12,73,25);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
      SuchenButton.addActionListener(lSymAction);
		//}}
	
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}
	}
	//{{DECLARE_CONTROLS
	javax.swing.JPanel KundendatenEingabePanel = new javax.swing.JPanel();
	javax.swing.JTextField AusweisTextField = new javax.swing.JTextField();
	javax.swing.JTextField KartenTextField = new javax.swing.JTextField();
	javax.swing.JTextField NameTextField = new javax.swing.JTextField();
	javax.swing.JTextField AlterTextField = new javax.swing.JTextField();
   javax.swing.JTextField KundenAddrTextFieldStrasse = new javax.swing.JTextField();
   javax.swing.JTextField KundenAddrTextFieldHausNummer  = new javax.swing.JTextField();
   javax.swing.JTextField KundenAddrTextFieldPLZ  = new javax.swing.JTextField();
	javax.swing.JLabel NameLabel = new javax.swing.JLabel();
	javax.swing.JLabel AddressLabelStrasse = new javax.swing.JLabel();
	javax.swing.JLabel AddressLabelHausnummer = new javax.swing.JLabel();
	javax.swing.JLabel AddressLabelPLZ = new javax.swing.JLabel();
	javax.swing.JLabel AusweisLabel = new javax.swing.JLabel();
	javax.swing.JLabel KartenLabel = new javax.swing.JLabel();
	javax.swing.JLabel AlterLabel = new javax.swing.JLabel();
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JButton SuchenButton = new javax.swing.JButton();
	//}}
	//{{DECLARE_MENUS
	//}}
	
	//{{additional properties
   KundenInfoAnReservierung ZuReservierung;
	kunde.PrivatKunde pkKunde;
	//}}
    
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
         if (object == SuchenButton)
				SuchenButton_actionPerformed(event);

		}
	}


   void SuchenButton_actionPerformed(java.awt.event.ActionEvent event)
	{
      String sName = new String (this.NameTextField.getText());
      kunde.PrivatKunde pkKundeTmp;
      

      if (sName.length() == 0){
        FehlerMeldungBox meldung =  new FehlerMeldungBox(null,"","Bitte einen Namen eingeben!!",false);
        meldung.setVisible(true);
      }else{
         pkKundeTmp = null;
         pkKundeTmp = Starter.pklPrivatKundenListe.kundeSuchen(sName);
         if(pkKundeTmp != null){
            bKundeBekannt = true;     
            kunde.Adresse ad;
            ad = pkKundeTmp.holeAdresse();
            KundenAddrTextFieldHausNummer.setText((new Integer(ad.holeHausNummer())).toString());
            KundenAddrTextFieldPLZ.setText((new Integer(ad.holePLZ())).toString());
            KundenAddrTextFieldStrasse.setText(ad.holeStrasse());
            AlterTextField.setText((new Integer(pkKundeTmp.holeAlter())).toString());
            KartenTextField.setText(pkKundeTmp.holeKreditkarte());
            AusweisTextField.setText(pkKundeTmp.holeAusweisnummer());
      
            pkKunde=pkKundeTmp;
         }     
      }      
   
   }
   
	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
      boolean bAngabenRichtig = true;
      
      try{
         if (bKundeBekannt == false){ //
            kunde.Adresse ad = new kunde.Adresse(KundenAddrTextFieldStrasse.getText(),
                  KundenAddrTextFieldHausNummer.getText(),
                  (new Integer(KundenAddrTextFieldPLZ.getText())).intValue());
            //Aus den eingegebenenen Daten einen neuen Kunden erzeugen
            pkKunde = new kunde.PrivatKunde(
               NameTextField.getText(),
               ad,
               AusweisTextField.getText(),
               (new Integer(AlterTextField.getText())).intValue(),
               KartenTextField.getText()
            ); 
            //das Neue Element in der Liste der Kunden eintragen.
            Starter.pklPrivatKundenListe.addElement(pkKunde);
      }
      }catch(java.lang.Exception e) {
         bAngabenRichtig = false;
         FehlerMeldungBox dialog = new FehlerMeldungBox(null,"","Sie haben falsche Eingaben gemacht!",false);
         dialog.setVisible(true);
      }
      if (bAngabenRichtig){
	      ZuReservierung.privatKundeInfoLiefern(pkKunde); //methode des Interfaces
         this.setVisible(false);
	      this.dispose();
      }
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PrivatKundeEingabe.this)
				PrivatKundeEingabe_windowClosing(event);
		}
	}

	void PrivatKundeEingabe_windowClosing(java.awt.event.WindowEvent event)
	{
		PrivatKundeEingabe_windowClosing_Interaction1(event);
	}

	void PrivatKundeEingabe_windowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			// PrivatKundeEingabe Hide the PrivatKundeEingabe
			this.setVisible(false);
			this.dispose();            // free the system resources
		} catch (java.lang.Exception e) {
		}
	}


   //********************MAIN******************************
  static public void main(String[] args)
	{
		try {
		    (new PrivatKundeEingabe()).setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}
	//*********************************************

}
