//Titel:      DVTAuto
//Version:    
//Copyright:  Copyright (c) 2000
//Autor:     Nathalie Poerwantoro, Shahriar Fakher
//Organisation:    Lerhrgebiet Datenverarbeitungstechnik FernUni-Hagen

import javax.swing.UIManager;
import java.awt.*;
import kunde.*;
import fahrzeug.*;
import dvtautoio.*;

/**
 * Von hier aus startet das Programm 
 */
public class Starter {
  boolean packFrame = false;
  public static PrivatKundenListe pklPrivatKundenListe;
  public static FirmenKundenListe fklFirmenKundenListe;
  public static LaufendeVertraege mvlMietvertragListe;
  public static Reservierungen rlReservierungen;
  
  
  
  //Anwendung konstruieren
  public Starter() {
    StarterFrame frame = new StarterFrame();
    //Frames validieren, die eine voreingestellte Gre besitzen
    //Frames packen, die ntzliche bevorzugte Infos ber die Gre besitzen, z.B. aus ihrem Layout
    if (packFrame)
      frame.pack();
    else
      frame.validate();
    //Fenster zentrieren
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  //Main-Methode
  public static void main(String[] args) {
    DVTAutoIO ioStream;
    
    fklFirmenKundenListe = new FirmenKundenListe();
    pklPrivatKundenListe = new PrivatKundenListe();
    
    if (0 != args.length){
      if (0 == args[0].compareToIgnoreCase("-d")){
 		   DummyDatenErzeuger me = new DummyDatenErzeuger();
		   me.createDummyFirmenkunde();
		   me.createDummyKompakt();
		   me.createDummyPrivatkunden();
		   me.createDummyReservierungCounter();
		   me.createDummyReservierung();
		   me.createDummyMietvertrag();     
      }
    }else{
      ioStream = new DVTAutoIO();   
      fklFirmenKundenListe =  (FirmenKundenListe)ioStream.datenBloeckeEinlesen(fklFirmenKundenListe);
      pklPrivatKundenListe =  (PrivatKundenListe)ioStream.datenBloeckeEinlesen(pklPrivatKundenListe);

      
    
      try  {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      }
      catch(Exception e) {
      }
      new Starter();
      }
   }
}
 
