package fahrzeug;

/**
 * Beinhaltet das Datum fr den Miettermin.
 * Es werden Jahr, Monat, Tag und Stunde abgespeichert.
 * 
 * @author Shahriar
 * @author Nathalie
 */
public class Datum implements java.io.Serializable{
    private int JJ;
    private int MM;
    private int TT;
    private int SS;
    private java.util.GregorianCalendar cal;
    
    public Datum(int jahr, int monat, int tag, int stunde)
    {
     this.setzeJJ(jahr);
     this.setzeMM(monat);
     this.setzeTT(tag);
     this.setzeSS(stunde);
     cal = new java.util.GregorianCalendar(JJ,MM,TT,SS,0); //minute wird auf 0 gesetzt, da irrellevant
    }
    
    public int holeJJ(){
            return JJ;
        }

    public void setzeJJ( int jahr){
            this.JJ = jahr;
        }

    public int holeMM(){
            return MM;
        }

    public void setzeMM( int monat){
            this.MM = monat;
        }

    public int holeTT(){
            return TT;
        }

    public void setzeTT( int tag){
            this.TT = tag;
        }

    public int holeSS(){
            return SS;
        }

    public void setzeSS( int stunde){
            this.SS = stunde;
        }

   public java.util.GregorianCalendar holeCal()
   {
    return cal;
    }
   
    public Datum datumsDifferenzBerechnen()
    {
     return null;
    }

    public float anzahlTageAusgeben() //berechnet im Bezug auf Jan 1 1970 in milisecs, umwandeln auf tage
    {
      return (((cal.getTime()).getTime())/1000)/(24*60*60); 
    }

    public int anzahlRestStundenAusgeben() { return 0;
    }

    
}
