package fahrzeug;

import java.util.Vector;
import kunde.Liste;
import kunde.ListeNachNamenSortiert;
import Starter;

/**
 * Hier ist eine Ableitung der Listen-Klasse, die zur Verwaltung der einzelnen Fahrzeuge verwendet wird.
 * @author Shahriar
 *
 */
public class FahrzeugBestand extends Liste {
     /**
     * @link aggregation
     * @clientCardinality 1
     * @supplierCardinality 0..*
     */
   private Fahrzeug lnkFahrzeug;

   public Vector eintraegeAuflisten(){
   Vector v;
   int i;

   v = new Vector();

     for (i=0;i<this.size()-1;i++){
        v.addElement(this.elementAt(i));
     }
    return(v);
   }

   public Vector eintraegeAuflisten(boolean _bVerfuegbar){
      int i;
      Vector v;

      v = new Vector();

      for (i = 0 ; i <= (this.size()-1);i++){
         if (((Fahrzeug)(this.elementAt(i))).istVerfuegbar())v.addElement(this.elementAt(i));
      }
      if(v.isEmpty())
        return null;  //wurde vereinbart listen geben null zurueck wenn eintrag nicht gefunden
      else
        return (v);
   }

   public boolean eintragLoeschen(Object _oObject){
      return (this.removeElement(_oObject));
   }

   public void neuerEintrag(Object _oObject){
      this.addElement(_oObject);
   }

   public void neuesFahrzeugEintragen(Object _oFahrzeug) {
      neuerEintrag(_oFahrzeug);
   }

   public void FahrzeugLoeschen(int _iNummernSchild) {
      this.eintragLoeschen(FahrzeugSuchen(_iNummernSchild));
   }

   public Fahrzeug FahrzeugSuchen(int _iNummernSchild){
      int iAnfang=0, iEnde, i=iAnfang;

      iEnde = ((this.size())-1);

      if (iEnde == -1 ) return(null); //Leere Liste
      while(
         (i != iEnde) &&
         (_iNummernSchild != ((Fahrzeug)this.elementAt(i)).iNummernschild)
           )i++;
      if ((_iNummernSchild == ((Fahrzeug)this.elementAt(i)).iNummernschild))return ((Fahrzeug)this.elementAt(i));
      else return(null);
   }
}
