package kunde;

import java.util.Vector;


/**
 * Hier sind die einzelnen Firmenkunden registriert
 * @author Shahriar
 * 
 */
public class FirmenKunde extends Kunde implements java.io.Serializable{

    
    protected int iKontonummer;
    protected int iFirmenkundenNummer;
    /**
     * @label
     * @link aggregation
     * @undirected
     * @clientCardinality 1
     * @supplierCardinality 1..*
     * @clientRole
     * @supplierRole
     * @clientQualifier
     * @supplierQualifier 
     */
    private Vector lnkFirmenmitglieder;


    public FirmenKunde(
            String _sName,
            Adresse _adAnschrift,
            int _iKontonummer,
            int _iFirmenKundenNummer
            ){

      setzeName(_sName);   
      setzeAdresse(_adAnschrift);
      setzeKontoNummer( _iKontonummer) ;
      setzeFirmenKundenNummer(_iFirmenKundenNummer);
      lnkFirmenmitglieder = new Vector();
    }

    public void fahrerZulassen(FirmenMitglieder _fmNeuerfahrer) {
      lnkFirmenmitglieder.addElement(_fmNeuerfahrer);
    }

    public void fahrerLoeschen(String _sName) {
      int i=0, iEnde;
      iEnde = lnkFirmenmitglieder.size()-1;

      //die Liste solage durchsuchen, bis entweder der 
      //richtige Eintrag gefunden wird, oder das Ende der Liste erreicht ist      
      while((i <= iEnde) && (0 != (( (FirmenMitglieder)(lnkFirmenmitglieder.elementAt(i))).sName.compareTo(_sName)))) i++;
      //Ueberpruefen, ob wirklich der richtige Eintrag gefunden wurde, und loeschen
      if (0 == (( (FirmenMitglieder)(lnkFirmenmitglieder.elementAt(i))).sName.compareTo(_sName))){
         lnkFirmenmitglieder.removeElement(lnkFirmenmitglieder.elementAt(i));
      }
    }

    public void kundenKarteDrucken() {
    }
    public int holeKontoNummer(){
      return ( iKontonummer);
    }
    public int holeKundenNummer(){
      return (iFirmenkundenNummer);
    }

    public int holeFirmenKundenNummer(){
      return (iFirmenkundenNummer);
    }
    public void setzeKontoNummer(int _iKontoNummer){
      iKontonummer=_iKontoNummer;
    }
    public void setzeFirmenKundenNummer(int _iFirmenKundenNummer){
      iFirmenkundenNummer=_iFirmenKundenNummer;
    }
    
    public Vector holeLnkFirmenmitglieder()
    {
      return lnkFirmenmitglieder;    
    }
    
    public void setzeLnkFirmenmitglieder(Vector mitglieder)
    {
     lnkFirmenmitglieder = mitglieder;
    }
}
