package kunde;

import java.util.Vector;
import Starter;

/**
 * Hier ist die sortierte Liste der Firmenkunden.
 * @author Shahriar 
 */
 
public class FirmenKundenListe extends ListeNachNamenSortiert {
    /**
     * Loeschen eines Firmenkundeneintrages 
     * gegeben wird die FirmenkundenNummer (String) 
     */


    public boolean firmenkundenDatenLoeschen(int _iFirmenkundeNummer) {
      return (this.eintragLoeschen(firmenKundeNachNummerSuchen(_iFirmenkundeNummer)));
    }

    public Vector firmenKundenAuflisten(int _iFirmenKundeNummer) {
         int iAnfang=0, iEnde, i=iAnfang;
         Vector v;
         iEnde = (this.size()-1);
         v = new Vector();

         while(i != iEnde){
            if ( _iFirmenKundeNummer ==((FirmenKunde) this.elementAt(i)).iFirmenkundenNummer){
               v.addElement(this.elementAt(i));   
            }
            i++;
         }
         return (v);
    }

    /**
     * Suchen einer Firmenkunde anhand gegebenem Firmenkundennummer*/
    public FirmenKunde firmenKundeNachNummerSuchen(int  _iKundenNummer) {
       int iAnfang=0, iEnde, i=iAnfang;
       iEnde = (this.size()-1);
       if (iEnde == -1) return (null);
       while((i != iEnde) && !(_iKundenNummer == ((FirmenKunde) Starter.fklFirmenKundenListe.elementAt(i)).iFirmenkundenNummer))i++;
       return ((FirmenKunde)Starter.fklFirmenKundenListe.elementAt(i));
    }

    public void neuenFirmenKundenEintragen(FirmenKunde _fkKunde){
      neuerEintrag(_fkKunde);
    }

    /**
     * Suchen einer Firmenkunde anhand gegebenem Firmenkundennamen*/
    public FirmenKunde firmenKundeNachNamenSuchen(String _sName) {
       int iAnfang=0, iEnde, i=iAnfang;
       iEnde =  ( Starter.fklFirmenKundenListe.size()-1  );
       if (iEnde == -1) return (null);
       while(
         (i < iEnde) && 
         ( 0 != _sName.compareToIgnoreCase(((FirmenKunde)Starter.fklFirmenKundenListe.elementAt(i)).sName) )  
            )i++;
       if (0 == _sName.compareToIgnoreCase(((FirmenKunde)Starter.fklFirmenKundenListe.elementAt(i)).sName))return ((FirmenKunde)Starter.fklFirmenKundenListe.elementAt(i));
       else return(null);
    }


    /**
     * @link aggregation
     * @clientCardinality 1
     * @supplierCardinality 0..* 
     */
    private FirmenKunde lnkFirmenkunde;
    private Vector FirmenKunden;
}
