package kunde;

import java.util.*;

/**
 * Dies ist eine Ableitung der Abstrakten Listen-Klasse. Die Eintrge, die neu hinzugefgt werden, werden automatisch nach Namen sortiert.
 * @author Shahriar 
 */
 
public class ListeNachNamenSortiert extends Liste  implements java.io.Serializable{
   
    public Vector eintraegeAuflisten(){
    Vector v;
    int i;

    v = new Vector();

      for (i=0;i<this.size()-1;i++){
         v.addElement(elementAt(i));
      }
     return(v);
    }

    public boolean eintragLoeschen(Object _oObject){
      return(removeElement(_oObject));
    }

    //Hier werden die Eintrge automatisch so einsortiert, da die Liste 
    //immer in alphabetische Reihnfolge sortiert ist!
    public void neuerEintrag(Object  _oObject) {
      try {
         int s = 0, e = this.size(), m, ms;
         int cres;
  
         // catch the special cases of the empty list and the one-element list
         if(e == 0) {
           addElement(_oObject);
           return;
         }
       if(e == 1) {
           cres = (((Kunde) elementAt(0)).sName).compareTo(((Kunde) _oObject).sName );
           if(cres == 0)       // m == el
             return;
           else if(cres < 0)   // m < el
             insertElementAt(_oObject, 1);
           else // (cres > 0)  // m > el
             insertElementAt(_oObject, 0);
           return;
         }
         // now go for it: the loop runs until the binary partitioning of the list
         // returns the same middle-index twice. (Interesting, isn't it?) When this
         // is the case, e is the position to insert the new element.
         ms = 1; m = 0;
         while(ms != m) {
           ms = m;
           m = (e + s) / 2;
           //cres = ((String) this.elementAt(m)).compareTo(el);
           cres = (((Kunde) elementAt(m)).sName).compareTo(((Kunde) _oObject).sName );
           if(cres == 0)         // m == el
             return;
           else if(cres < 0)     // m < el
             s = m;
           else  // (cres > 0)   // m > el
             e = m;
         }
         insertElementAt(_oObject, e);                                       
       }
       // This will never come, but java requires a catch for proper compilation. 
       catch(ArrayIndexOutOfBoundsException e) {
         System.out.println("Caught oob csize == " + this.size());
         addElement(_oObject);
       } 
     } //Algorithmus in Anlehnung an Sortieralgorithmus von Marc Jackisch, 1997!
}
