package kunde;

import java.lang.*;

/**
 * Hier sind die Privatkunden registriert
 * @author Shahriar 
 * 
 */

public class PrivatKunde extends Kunde implements java.io.Serializable {

   protected String sAusweisnummer;
   protected int iAlter;
   protected String sKreditkarte;


   public PrivatKunde(
      String _sName, 
      Adresse _adAdresse, 
      String _sAusweisnummer, 
      int _iAlter, 
      String _sKreditkarte ){

      setzeName(_sName);
      setzeAdresse(_adAdresse);
      setzeAusweisnummer(_sAusweisnummer);
      setzeAlter(_iAlter);
      setzeKreditkarte(_sKreditkarte);
   }
   public void setzeAusweisnummer(String _sAusweisnummer){
      sAusweisnummer = new String(_sAusweisnummer);
   }
   public void setzeAlter(int _iAlter){
      iAlter = _iAlter;
   }
   public void setzeKreditkarte(String _sKreditKarte){
      sKreditkarte = new String(_sKreditKarte);
   }
   public String holeAusweisnummer(){
      return(sAusweisnummer);
   }
   public int holeAlter(){
      return(iAlter);
   }
   public String holeKreditkarte(){
      return(sKreditkarte);
   }
   public void privatKundeUpdate(Adresse _adAdresse, 
                                 String _sAusweisnummer,
                                 int _iAlter, 
                                 String _sKreditkarte ){
      if (_adAdresse != null){
         setzeAdresse(_adAdresse);
      }
      if(_sAusweisnummer.length()>0){
         setzeAusweisnummer(_sAusweisnummer);
      }
      if(_iAlter >= 0){
         setzeAlter(_iAlter);
      }
      if(_sKreditkarte.length()>0){
         setzeKreditkarte(_sKreditkarte);
      }
   }

}
