package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import fahrzeug.*;
import kunde.*;

/**
 * Beinhaltet eine Liste der Angebote wo Sonderwnsche und Kundentyp mitbercksichtigt werden
 *
 * @author Nathalie
 */
public class DetailAngebot extends javax.swing.JFrame
{

 public DetailAngebot()
 {
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setSize(524,355);
		setVisible(false);
		FahrzeugListPanel.setLayout(null);
		getContentPane().add(FahrzeugListPanel);
		FahrzeugListPanel.setBackground(java.awt.Color.white);
		FahrzeugListPanel.setBounds(0,0,525,288);
		FahrzeugdetailScroll.setOpaque(true);
		FahrzeugListPanel.add(FahrzeugdetailScroll);
		FahrzeugdetailScroll.setBounds(0,0,312,288);
		FahrzeugdetailScroll.getViewport().add(FahrzeugDetailTextArea);
		FahrzeugDetailTextArea.setBounds(0,0,309,285);
		FahrzeugDetailTextArea.setEditable(false);
		FahrzeugListPanel.add(BildAuto);
		BildAuto.setBounds(312,120,212,168);
		BildAuto.setBackground(Color.white);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,288,525,57);
		PrevButton.setText("<");
		PrevButton.setActionCommand("<");
		NavPanel.add(PrevButton);
		PrevButton.setBounds(288,12,73,25);
		WeiterButton.setText(">");
		WeiterButton.setActionCommand(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(372,12,73,25);
		SeiteTextField.setDisabledTextColor(java.awt.Color.gray);
		NavPanel.add(SeiteTextField);
		SeiteTextField.setBackground(new java.awt.Color(226,228,241));
		SeiteTextField.setBounds(456,12,58,28);
		SeiteTextField.setEditable(false);
		SelectButton.setText("Auswhlen");
		SelectButton.setActionCommand("Auswhlen");
		NavPanel.add(SelectButton);
		SelectButton.setBounds(180,12,97,25);
		exitButton.setText("Ende");
		exitButton.setActionCommand("Auswhlen");
		NavPanel.add(exitButton);
		exitButton.setBounds(72,12,97,25);
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		SelectButton.addActionListener(lSymAction);
		PrevButton.addActionListener(lSymAction);
		WeiterButton.addActionListener(lSymAction);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		exitButton.addActionListener(lSymAction);
		//}}
	}

 public DetailAngebot(Kundenanfrage zuKunde,String kategorie,String klasse)
  {
  this();
  PrevButton.setEnabled(false);
  zuKundenanfrage = zuKunde;
  fzgListe = zuKundenanfrage.holeErzeugteAngebot();
  fzgListeSize = fzgListe.size();
  FahrzeugHeader= "Kategorie: "+zuKundenanfrage.holeKategorieText()+" \n"+"Klasse: "+zuKundenanfrage.holeKlasseText()+" \n";
  zeigeAutoInformation();

  }

	//{{DECLARE_CONTROLS
	javax.swing.JPanel FahrzeugListPanel = new javax.swing.JPanel();
	javax.swing.JScrollPane FahrzeugdetailScroll = new javax.swing.JScrollPane();
	javax.swing.JTextArea FahrzeugDetailTextArea = new javax.swing.JTextArea();
	javax.swing.JLabel BildAuto = new javax.swing.JLabel();
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton PrevButton = new javax.swing.JButton();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JTextField SeiteTextField = new javax.swing.JTextField();
	javax.swing.JButton SelectButton = new javax.swing.JButton();
	javax.swing.JButton exitButton = new javax.swing.JButton();
	//}}
	//{{DECLARE_MENUS
	//}}

    //{{addditional properties
    Kundenanfrage zuKundenanfrage;
    Angebote fzgListe;
	String FahrzeuginfoOutput = new String();
	String FahrzeugHeader = new String();
	int listPositionCounter =0;
	int fzgListeSize;
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == SelectButton)
				SelectButton_actionPerformed(event);
			else if (object == PrevButton)
				PrevButton_actionPerformed(event);
			else if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
			else if (object == exitButton)
				exitButton_actionPerformed(event);
		}
	}

	void SelectButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		SelectButton_actionPerformed_Interaction1(event);
	}

	void SelectButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	  //haelt den gewaehlter Fahrzeug fest
	  (zuKundenanfrage.holeErzeugteAngebot()).setzeGewaehltesFahrzeug((MietpreisDesFahrzeugs)(zuKundenanfrage.holeErzeugteAngebot()).elementAt(listPositionCounter));
	   //ruft die Interfaceimplementierung um den gewaehlten Fahrzeug an das Reservierungssystem weiterzugeben
	   zuKundenanfrage.angebotUebergabe();
	   //Frame schliessen und aus dem Speicher holen
	   this.setVisible(false);
	   dispose();
	}

	void PrevButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		PrevButton_actionPerformed_Interaction1(event);
	}

	void PrevButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
      if(listPositionCounter > 0)
		 {
		  listPositionCounter--;
	      zeigeAutoInformation();
	     }

	  if(listPositionCounter == 0)
		 {
		  try {
			WeiterButton.setEnabled(true);
		    PrevButton.setEnabled(false);
		  } catch (java.lang.Exception e) {
		  }
		 }
		 else
		 {
		  WeiterButton.setEnabled(true);
		  PrevButton.setEnabled(true);
		  }

	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		if(listPositionCounter < fzgListeSize-1)
		 {
		  listPositionCounter++;
	      zeigeAutoInformation();
	     }

	     if(listPositionCounter == fzgListeSize-1)
		 {
		  try {
			WeiterButton.setEnabled(false);
		    PrevButton.setEnabled(true);
		  } catch (java.lang.Exception e) {
		  }
		 }
		 else
		 {
		  WeiterButton.setEnabled(true);
		  PrevButton.setEnabled(true);
		  }

	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == DetailAngebot.this)
				DetailAngebot_windowClosing(event);
		}
	}

	void DetailAngebot_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.

		DetailAngebot_windowClosing_Interaction1(event);
	}

	void DetailAngebot_windowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			this.setVisible(false);
			this.dispose();
		} catch (java.lang.Exception e) {
		}
	}

  //{{additional methods
   public void zeigeAutoInformation()
   {
     Fahrzeug tmpFzg = ((MietpreisDesFahrzeugs)fzgListe.elementAt(listPositionCounter)).holeLnkFahrzeug();
     AngebotPreise tmpPreis = ((MietpreisDesFahrzeugs)fzgListe.elementAt(listPositionCounter)).holeLnkAngebotPreise();
     String PreisOutput= "\n Tagespreis: \u20AC"+tmpPreis.holeTagesPreis()+"\n Stundenpreis: "+tmpPreis.holeStundenPreis()+"\n Gesamtmietpreis: \u20AC"+tmpPreis.holeGesamtPreis();
     if(zuKundenanfrage.isFirmenKunde())
        FahrzeuginfoOutput = FahrzeugHeader+ " \n Wochenpreis: \u20AC"+ String.valueOf(tmpFzg.holeWochenpreis()*0.8)+PreisOutput;
     else
        FahrzeuginfoOutput = FahrzeugHeader+ " \n Wochenpreis: \u20AC"+ String.valueOf(tmpFzg.holeWochenpreis())+PreisOutput;

     FahrzeugDetailTextArea.setText(FahrzeuginfoOutput);
     String tmpAbbildung = tmpFzg.holeImage();
     BildAuto.setIcon(new ImageIcon(tmpAbbildung));
     SeiteTextField.setText(listPositionCounter+"/"+String.valueOf(fzgListe.size()-1));
    }

   //}}



	void exitButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		exitButton_actionPerformed_Interaction1(event);
	}

	void exitButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			dispose();
		} catch (java.lang.Exception e) {
		}
	}
}
