package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import fahrzeug.*;
import kunde.*;
import java.io.*;
import dvtautoio.*;
import java.lang.Exception.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import Starter;
/**
 * Benutzerschnittstelle zur Behandlung des Mietendes. Mietvertragnummereingabe.
 * Eine Rechnung mit allen Kosten wird gezeigt.
 *
 * @author Nathalie
 */

public class MietendeGUI extends javax.swing.JFrame
{
/**
 */
 public MietendeGUI()
 {

		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		getContentPane().setBackground(java.awt.Color.white);
		setSize(564,520);
		setVisible(false);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,456,564,40);
		WeiterButton.setText(">");
		WeiterButton.setActionCommand(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(480,10,73,25);
		MietvertragnummerPanel.setLayout(null);
		getContentPane().add(MietvertragnummerPanel);
		MietvertragnummerPanel.setBackground(new java.awt.Color(226,228,241));
		MietvertragnummerPanel.setBounds(12,12,540,96);
		MietvertragsnummerLabel.setText("Mietvertragsnummer");
		MietvertragnummerPanel.add(MietvertragsnummerLabel);
		MietvertragsnummerLabel.setBounds(24,12,180,24);
		MietvertragnummerPanel.add(VertragnummerTextfield);
		VertragnummerTextfield.setBounds(180,12,232,26);
		MietvertragnummerPanel.add(ddTextField);
		ddTextField.setBounds(180,60,57,23);
		MietvertragnummerPanel.add(mmTextField);
		mmTextField.setBounds(252,60,57,23);
		MietvertragnummerPanel.add(yyTextField);
		yyTextField.setBounds(324,60,57,23);
		rueckgabeDatumLael.setText("Datum");
		MietvertragnummerPanel.add(rueckgabeDatumLael);
		rueckgabeDatumLael.setBounds(24,60,135,21);
		MietvertragnummerPanel.add(hhTextField);
		hhTextField.setBounds(456,60,57,23);
		hourLabel.setText("Zeit");
		MietvertragnummerPanel.add(hourLabel);
		hourLabel.setBounds(408,60,30,21);
		MietvertraginfoPanel.setLayout(null);
		getContentPane().add(MietvertraginfoPanel);
		MietvertraginfoPanel.setBackground(new java.awt.Color(226,228,241));
		MietvertraginfoPanel.setBounds(12,120,540,324);
		MietdatenScrollPane.setOpaque(true);
		MietvertraginfoPanel.add(MietdatenScrollPane);
		MietdatenScrollPane.setBounds(12,12,516,300);
		MietdatenScrollPane.getViewport().add(MietdatenTextPane);
		MietdatenTextPane.setBounds(0,0,513,297);
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
		//}}
	}
	//{{DECLARE_CONTROLS
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JPanel MietvertragnummerPanel = new javax.swing.JPanel();
	javax.swing.JLabel MietvertragsnummerLabel = new javax.swing.JLabel();
	javax.swing.JTextField VertragnummerTextfield = new javax.swing.JTextField();
	javax.swing.JTextField ddTextField = new javax.swing.JTextField();
	javax.swing.JTextField mmTextField = new javax.swing.JTextField();
	javax.swing.JTextField yyTextField = new javax.swing.JTextField();
	javax.swing.JLabel rueckgabeDatumLael = new javax.swing.JLabel();
	javax.swing.JTextField hhTextField = new javax.swing.JTextField();
	javax.swing.JLabel hourLabel = new javax.swing.JLabel();
	javax.swing.JPanel MietvertraginfoPanel = new javax.swing.JPanel();
	javax.swing.JScrollPane MietdatenScrollPane = new javax.swing.JScrollPane();
	javax.swing.JTextPane MietdatenTextPane = new javax.swing.JTextPane();
	//}}
	//{{DECLARE_MENUS
	//}}

	//{{additional properties
	short stepCounter =0;
	String vrtNummer = new String();
	LaufendeVertraege vrtgList;
	Mietvertrag vertrag;
	Reservierungen rsrListe;
	FahrzeugBestand fzgListe;
	String KundeZuLoeschen = new String();
	String mietStartDatum = new String();
	DVTAutoIO ListenOeffner = new DVTAutoIO();
	int treibstoffGrundpreis = 100;
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
		}
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		switch(stepCounter)
		{
		 case 0: //{{mietvertrag suchen, preis berechnen und zeigen
		         try{
		         vrtNummer = VertragnummerTextfield.getText();
		         System.out.println("Vertragsnummer:"+vrtNummer);
		         }
		         catch(java.lang.NullPointerException e)
		         {
		           (new GeneralDialog(this,"Bitte Mietvertragsnummer eingeben")).setVisible(true);
		           break;
		         }
		         if(vrtNummer.length() == 0)
		           {
		           (new GeneralDialog(this,"Bitte Mietvertragsnummer eingeben")).setVisible(true);
                    break;
                   }
                 vrtgList = (LaufendeVertraege)ListenOeffner.datenBloeckeEinlesen(new LaufendeVertraege());
		         vertrag = vrtgList.eintraegeAuflisten(vrtNummer);
		         if(vertrag == null)
		           {
		            (new GeneralDialog(this, "Mietvertragsnummer inkorrekt")).setVisible(true);
		            break;
		           }

		         //Ueberpruefen ob Fahrzeug schon zurueckgegeben wurde
		         String tmpFzgClass = vertrag.holeKategorieKlasse();
		         tmpFzgClass = tmpFzgClass.substring(tmpFzgClass.indexOf(".")+1);
		         fzgListe = (FahrzeugBestand)ListenOeffner.datenBloeckeEinlesen(new Object(),tmpFzgClass);
		         int tmpNummerSch = vertrag.holeNummernSchield();

                 Fahrzeug tmpFahrzeug = fzgListe.FahrzeugSuchen(tmpNummerSch);
                 if(!tmpFahrzeug.istVerfuegbar())
                  {//erst auto zurueckgeben
                   (new GeneralDialog(this, "Bitte Fahrzeug erst zurckgeben")).setVisible(true);
		            break;
		          }


		         //kundenname festhalten
		          KundeZuLoeschen = vertrag.holeKundenName();

		         //Reservierungen holen
                  rsrListe = (Reservierungen)ListenOeffner.datenBloeckeEinlesen(new Reservierungen());

                 //{{Preis berechnen : version 2 Datum Ueberpruefen
                   Datum rueckgabeDatum;
                   int totalMietPreis=0;
                   try{
	                //yy,mm,dd:hh
	                int tmpEnde[]={Integer.parseInt(yyTextField.getText()),Integer.parseInt(mmTextField.getText()),Integer.parseInt(ddTextField.getText()),Integer.parseInt(hhTextField.getText())};

	                //zahlen gueltigkeit ueberpruefen
	                if((tmpEnde[1]>12)||(tmpEnde[1]<1)||(tmpEnde[2]>31)||(tmpEnde[2]<1)||(tmpEnde[3]>24)||(tmpEnde[3]<0))
	                {
	                    (new GeneralDialog(this,"Korrigieren Sie die Datumeingabedaten")).setVisible(true);
	                    break;;
	                }

	                //{{Datumeingabe ueberpruefen
	                java.util.GregorianCalendar tmpBeginn = vertrag.holeMietBeginn().holeCal();
                    String tmpStrBeginn = String.valueOf(tmpBeginn.get(Calendar.YEAR)).substring(2)+String.valueOf(tmpBeginn.get(Calendar.MONTH))+String.valueOf(tmpBeginn.get(Calendar.DAY_OF_MONTH))+String.valueOf(tmpBeginn.get(Calendar.HOUR_OF_DAY));
                    mietStartDatum = tmpStrBeginn;
                    java.util.GregorianCalendar tmpEndCal = new java.util.GregorianCalendar(tmpEnde[0],tmpEnde[1],tmpEnde[2],tmpEnde[3],0);
	                if(tmpBeginn.getTime().after(tmpEndCal.getTime()))
	                {
	                    (new GeneralDialog(this,"Rueckgabedatum kann nicht frher als Mietstartdatum sein!")).setVisible(true);
	                     break;
	                }

	                rueckgabeDatum = new Datum(tmpEnde[0],tmpEnde[1],tmpEnde[2],tmpEnde[3]);
                    float mietdauer = rueckgabeDatum.anzahlTageAusgeben() - vertrag.holeMietBeginn().anzahlTageAusgeben();
                    totalMietPreis = (int)(mietdauer * (float) rsrListe.eintraegeAuflisten(vrtNummer.substring(0,vrtNummer.length()-tmpStrBeginn.length())).holeFahrzeugInfo().holeLnkAngebotPreise().holeTagesPreis());


	                }
	                catch(java.lang.NumberFormatException e)
	                {
	                (new GeneralDialog(this,"Keine ganze Zahl")).setVisible(true);
	                 totalMietPreis = 0;
	                 break;
	                }



                  //}}

	           //tank zustand
                   float aktuellTank = fzgListe.FahrzeugSuchen(vertrag.holeNummernSchield()).holeTank();
                   String Kraftstoff = new String();
                   int treibstoffAufpreis = 0;
                   if(aktuellTank <= (0.25))
                     {
                      treibstoffAufpreis = (int) (0.75 * treibstoffGrundpreis);
                      Kraftstoff = "2/4";
                     }
                   else
                      if(aktuellTank <= (0.5))
                        {
                         treibstoffAufpreis = (int) (0.5 * treibstoffGrundpreis);
                         Kraftstoff = "1/2";
                        }
                       else
                           if(aktuellTank <= (0.75))
                             {
                              treibstoffAufpreis = (int) (0.25 * treibstoffGrundpreis);
                              Kraftstoff = "3/4";
                             }
                           else
                             Kraftstoff = "voll";


                  //Ausgabe vorbereiten
                  totalMietPreis= totalMietPreis+treibstoffAufpreis;
                  String ausgabe = new String("\nRechnung \n");
                  ausgabe += "\n Mietvertragsnummer: "+ vertrag.holeVertragsNummer()+ "\n Kundenname: "+ vertrag.holeKundenName()+"\n Mietbeginn: "+ vertrag.holeMietBeginn().holeTT()+"."+vertrag.holeMietBeginn().holeMM()+"."+vertrag.holeMietBeginn().holeJJ()+" um "+vertrag.holeMietBeginn().holeSS()+ " Uhr"+
                             "\n Rckgabe: "+rueckgabeDatum.holeTT()+"."+rueckgabeDatum.holeMM()+"."+rueckgabeDatum.holeJJ()+" um "+rueckgabeDatum.holeSS()+" Uhr"+
                             "\n Kraftstoff: "+Kraftstoff+
                             "\n Treibstoffpreis: \u20AC"+treibstoffAufpreis+
                             "\n Gesamtpreis: \u20AC"+totalMietPreis;
                  MietdatenTextPane.setText(ausgabe);
                  MietdatenTextPane.setEditable(false);
                  MietdatenTextPane.invalidate();
                  stepCounter++;
                  VertragnummerTextfield.setEditable(false);
		          break;
		 case 1:
		            /*reservierte Fahrzeug wieder Freigeben, soll schon beim Abgabe fregegeben werden
		            DVTAutoIO fahrzeugOeffner = new DVTAutoIO();
                    int tmpNummerSch = vertrag.holeNummernSchield();
                    Fahrzeug tmpFahrzeug = fzgListe.FahrzeugSuchen(tmpNummerSch);
                    tmpFahrzeug.setVerfuegbar(true);
                    fzgListe.FahrzeugLoeschen(tmpNummerSch);
                    fzgListe.neuerEintrag(tmpFahrzeug);
                    String tmpName = tmpFahrzeug.holeClass().getName();
                    tmpName = tmpName.substring(tmpName.indexOf('.')+1);
                    fahrzeugOeffner.datenBloeckeAusschreiben(fzgListe,tmpName);
                    */


		        //abbuchen, vertrag loeschen, privatkunde loeschen falls kein andere mietvertrag oder reservierung existieren
		        (new GeneralDialog(this,"Betrag abgebucht, vielen Dank")).setVisible(true);
		        //Mietvertrag loeschen
		        vrtgList.eintragLoeschen(vrtNummer);
		        ListenOeffner.datenBloeckeAusschreiben(vrtgList);


		        //Reservierung loeschen
		        String rsrNummer = vrtNummer.substring(0,vrtNummer.length()-mietStartDatum.length());
		        rsrListe.eintragLoeschen(rsrNummer);
		        ListenOeffner.datenBloeckeAusschreiben(rsrListe);
		        if(vertrag.IsisFirmenKunde())
		         {//firmenkunde, beendet
		           setVisible(false);
		           dispose();
		          }
		        else
		         {//privatkunde -> suche nach weitere eintraege
		           if(vrtgList.eintraegeAuflistenKunden(KundeZuLoeschen)!= null)
		           {//noch ein Mietvertrag fuer diesen Privatkunde, beendet
		            setVisible(false);
		            dispose();
		           }
		           else
		           {//ueberpruefe Reservierungen
		            if(rsrListe.eintraegeAuflistenKunden(KundeZuLoeschen)!= null)
		             {//noch ein Reservierung fuer diesen Privatkunde, beendet
		             setVisible(false);
		             dispose();
		             }
		             else
		             {//Privatkunde eliminieren
		               Starter.pklPrivatKundenListe.kundenDatenLoeschen(KundeZuLoeschen);
		               (new GeneralDialog(this,"Privatkundendaten gelscht")).setVisible(true);
		              }
		            }
		         }
		        setVisible(false);
		        dispose();
		        break;
		}
	}

  //{{***************MAIN*********************

    static public void main(String args[])
    {
     try{
        (new MietendeGUI()).setVisible(true);
     }
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}

    }
    //}}****************************************



}
