package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import fahrzeug.*;
import dvtautoio.*;
import kunde.*;
import java.util.Calendar;
/**
 * Zeigt den detailierten Mietvertrag an
 *
 * @author Nathalie
 */


public class MietvertragDialog extends javax.swing.JDialog
{

 public MietvertragDialog(Frame fr,Mietvertrag mt,Reservierung rsr)
 {
  this(fr);
  java.util.GregorianCalendar tmpBeginn = mt.holeMietBeginn().holeCal();
  String tmpStrBeginn =String.valueOf(tmpBeginn.get(Calendar.DAY_OF_MONTH))+"." +String.valueOf(tmpBeginn.get(Calendar.MONTH))+"."+String.valueOf(tmpBeginn.get(Calendar.YEAR)).substring(2)+" um "+String.valueOf(tmpBeginn.get(Calendar.HOUR_OF_DAY))+" Uhr";

  //Mietdauer und Preis holen
  int mietdauertage = (int)(rsr.holeLnkMietTermin().holeRueckgabeDatum().anzahlTageAusgeben()-rsr.holeLnkMietTermin().holeStartDatum().anzahlTageAusgeben());

  String MietProtokoll= new String("Mietvertrag \n");
  MietProtokoll+= "\n Kundenname: "+ mt.holeKundenName()+"\n Mietvertragsnummer: "+ mt.holeVertragsNummer()+ "\n Mietbeginn: "+ tmpStrBeginn+"\n Fahrzeugnummernschild: "+mt.holeNummernSchield()+"\n Fahrzeugstandort: "+mt.holeFahrzeugStandort()+"\n KM-Stand: "+ mt.holeKmStand()+"\n Kategorie: "+mt.holeKategorieKlasse().substring(mt.holeKategorieKlasse().indexOf(".")+1)+"\n Fllstand der Tankanzeige: voll"+"\n Mietdauer: "+mietdauertage+" Tage"+"\n Preis: \u20AC"+rsr.holeFahrzeugInfo().holeLnkAngebotPreise().holeGesamtPreis()+"\n Preis pro Tag: \u20AC"+rsr.holeFahrzeugInfo().holeLnkAngebotPreise().holeTagesPreis()+"\n Pris pro Stunde: \u20AC"+rsr.holeFahrzeugInfo().holeLnkAngebotPreise().holeStundenPreis();
  if(mt.IsisFirmenKunde())
    MietProtokoll += "\n Firmenkundennummer: "+ mt.holeFirmenkundenNummer()+ "\n Fahrer: "+ mt.holeFahrerName();

 MietTextArea.setText(MietProtokoll);
 MietTextArea.setEditable(false);
 }

 public MietvertragDialog(Frame fr)
 {
		super(fr);
		setModal(true);
		setTitle("Mietvertrag");
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		getContentPane().setBackground(new java.awt.Color(221,226,241));
		setSize(482,410);
		setVisible(false);
		getContentPane().add(MietScrollPane);
		MietScrollPane.setBounds(20,12,444,324);
		MietScrollPane.getViewport().add(MietTextArea);
		MietTextArea.setBounds(0,0,441,321);
		okButton.setText("OK");
		getContentPane().add(okButton);
		okButton.setBounds(180,340,129,34);
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		//}}
	}

	//{{DECLARE_CONTROLS
	javax.swing.JScrollPane MietScrollPane = new javax.swing.JScrollPane();
	javax.swing.JTextArea MietTextArea = new javax.swing.JTextArea();
	javax.swing.JButton okButton = new javax.swing.JButton();
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_actionPerformed(event);
		}
	}

	void okButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		okButton_actionPerformed_Interaction1(event);
	}

	void okButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			this.dispose();
		} catch (java.lang.Exception e) {
		}
	}
}
