package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import fahrzeug.*;
import dvtautoio.*;
import kunde.*;
/**
 * Benutzerschnittstelle zur Mietvertragvorbereitung. Kundenreservierung und Fhrerschein werden als Eingaben erwartet
 * 
 * @author Nathalie
 */

public class MietvertragGui extends javax.swing.JFrame
{
 
 public MietvertragGui(KundenAngaben zuKundeMiet)
 {
  this();
  zuKundenMietAngabe = zuKundeMiet;
  
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}
	}
 
 public MietvertragGui(KundenAngaben lnkZuKunde, String rsvr_nummer, String knd_name, String fzg_nummer,String fzg_stdort) 
 {
  this(lnkZuKunde);
  ReservierungsTextField.setText(rsvr_nummer);
  KundennamenTextField.setText(knd_name);
  FahrzeugnummerTextField.setText(fzg_nummer);
  StandortTextField.setText(fzg_stdort);
  this.validate();
  stageCounter = 2; // stage 0: kunden, stage 1: fahrzeug nummer und standort, stage 2: fuehrerschein
  ReservierungsTextField.setEditable(false);
 }

 public MietvertragGui(){
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		getContentPane().setBackground(java.awt.Color.white);
		setSize(497,450);
		setVisible(false);
		ReservierungcheckPanel.setBorder(ReservierungcheckBorder);
		ReservierungcheckPanel.setLayout(null);
		getContentPane().add(ReservierungcheckPanel);
		ReservierungcheckPanel.setBackground(new java.awt.Color(226,228,241));
		ReservierungcheckPanel.setBounds(12,12,468,84);
		ReservierungcheckPanel.add(ReservierungsTextField);
		ReservierungsTextField.setBounds(168,12,266,27);
		ReservierungcheckPanel.add(KundennamenTextField);
		KundennamenTextField.setBounds(168,48,266,27);
		KundennamenTextField.setEditable(false);
		ReservierungsnummerLabel.setText("Reservierungsnummer");
		ReservierungcheckPanel.add(ReservierungsnummerLabel);
		ReservierungsnummerLabel.setBounds(12,12,135,27);
		KundennamenLabel.setText("Kundennamen");
		ReservierungcheckPanel.add(KundennamenLabel);
		KundennamenLabel.setBounds(12,48,144,24);
		FahrzeugInfoPanel.setBorder(FahrzeuginfoBorder);
		FahrzeugInfoPanel.setLayout(null);
		getContentPane().add(FahrzeugInfoPanel);
		FahrzeugInfoPanel.setBackground(new java.awt.Color(226,228,241));
		FahrzeugInfoPanel.setBounds(12,108,468,84);
		StandortLabel.setText("Standort");
		FahrzeugInfoPanel.add(StandortLabel);
		StandortLabel.setBounds(12,48,125,26);
		FahrzeugnummerLabel.setText("Fahrzeugnummer");
		FahrzeugInfoPanel.add(FahrzeugnummerLabel);
		FahrzeugnummerLabel.setBounds(12,20,121,18);
		FahrzeugInfoPanel.add(FahrzeugnummerTextField);
		FahrzeugnummerTextField.setBounds(168,12,266,27);
		FahrzeugnummerTextField.setEditable(false);
		FahrzeugInfoPanel.add(StandortTextField);
		StandortTextField.setBounds(168,48,266,27);
		StandortTextField.setEditable(false);
		FuehrerscheinPanel.setLayout(null);
		getContentPane().add(FuehrerscheinPanel);
		FuehrerscheinPanel.setBackground(new java.awt.Color(226,228,241));
		FuehrerscheinPanel.setBounds(12,204,468,60);
		FuehrerscheinCheck.setText("Fhrerschein vorhanden");
		FuehrerscheinCheck.setActionCommand("Fhrerschein vorhanden");
		FuehrerscheinPanel.add(FuehrerscheinCheck);
		FuehrerscheinCheck.setBackground(new java.awt.Color(226,228,241));
		FuehrerscheinCheck.setBounds(12,12,300,29);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,350,497,40);
		WeiterButton.setText(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(420,10,73,25);
		MietvertragPanel.setBorder(MietvertragBorder);
		MietvertragPanel.setLayout(null);
		getContentPane().add(MietvertragPanel);
		MietvertragPanel.setBackground(new java.awt.Color(226,228,241));
		MietvertragPanel.setBounds(12,276,468,60);
		MietvertragLabel.setText("Mietvertragsnummer");
		MietvertragPanel.add(MietvertragLabel);
		MietvertragLabel.setBounds(12,15,147,28);
		MietvertragPanel.add(MietvertragsnummerTextField);
		MietvertragsnummerTextField.setBounds(168,15,266,27);
		MietvertragsnummerTextField.setBackground(new java.awt.Color(226,228,241));
		MietvertragsnummerTextField.setEditable(false);
		//$$ ReservierungcheckBorder.move(0,390);
		//$$ FahrzeuginfoBorder.move(24,390);
		//$$ MietvertragBorder.move(48,390);
		//$$ titledBorder1.move(0,390);
		//$$ titledBorder2.move(24,390);
		//$$ titledBorder3.move(48,390);
		//}}
	}
	//{{DECLARE_CONTROLS
	javax.swing.JPanel ReservierungcheckPanel = new javax.swing.JPanel();
	javax.swing.JTextField ReservierungsTextField = new javax.swing.JTextField();
	javax.swing.JTextField KundennamenTextField = new javax.swing.JTextField();
	javax.swing.JLabel ReservierungsnummerLabel = new javax.swing.JLabel();
	javax.swing.JLabel KundennamenLabel = new javax.swing.JLabel();
	javax.swing.JPanel FahrzeugInfoPanel = new javax.swing.JPanel();
	javax.swing.JLabel StandortLabel = new javax.swing.JLabel();
	javax.swing.JLabel FahrzeugnummerLabel = new javax.swing.JLabel();
	javax.swing.JTextField FahrzeugnummerTextField = new javax.swing.JTextField();
	javax.swing.JTextField StandortTextField = new javax.swing.JTextField();
	javax.swing.JPanel FuehrerscheinPanel = new javax.swing.JPanel();
	javax.swing.JCheckBox FuehrerscheinCheck = new javax.swing.JCheckBox();
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JPanel MietvertragPanel = new javax.swing.JPanel();
	javax.swing.JLabel MietvertragLabel = new javax.swing.JLabel();
	javax.swing.JTextField MietvertragsnummerTextField = new javax.swing.JTextField();
	javax.swing.border.TitledBorder ReservierungcheckBorder = new javax.swing.border.TitledBorder("Reservierungsdaten");
	javax.swing.border.TitledBorder FahrzeuginfoBorder = new javax.swing.border.TitledBorder("Fahrzeug");
	javax.swing.border.TitledBorder MietvertragBorder = new javax.swing.border.TitledBorder("Mietvertrag");
	//}}
	//{{DECLARE_MENUS
	//}}

    //{{additional properties
    short stageCounter=0;
    KundenAngaben zuKundenMietAngabe;
    boolean driverLic = false;
    //}}

   
   //{{accessor
   public void setDriverLic(boolean b)
     {
      driverLic = b;   
     }
     
   public boolean holeDriverLic()
   {
     return driverLic; 
   }
   //}}
   
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
		}
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		switch(stageCounter)
		{
		 //stage 0: kunden numzmmer
		 case 0:
		        String tmpKundenName = zuKundenMietAngabe.ueberpruefeReservierung(ReservierungsTextField.getText());
		        if(tmpKundenName != null)
		        {
		          if(tmpKundenName.equals("gemietet"))
		          {
		           //Reservierung nicht mehr gueltig, Auto schon gemietet
		           (new GeneralDialog(this,"Das Auto wurde schon gemietet")).setVisible(true);   
		          }
		          else
		          {
		           KundennamenTextField.setText(tmpKundenName);
		           KundennamenTextField.invalidate();
		           stageCounter++;
		           ReservierungsTextField.setEditable(false);
		          }
		        }
		        else
		        {
		         //Reservierung nicht akzeptiert
		         (new GeneralDialog(this,"Reservierungsnummer ungltig")).setVisible(true);   
		        }
		        break;
		 //stage 1: standort zeigen
		 case 1:
		        String[] tmpNrStandort = zuKundenMietAngabe.fahrzeugNummerStandortZeigen();
		        FahrzeugnummerTextField.setText(tmpNrStandort[0]);
		        StandortTextField.setText(tmpNrStandort[1]);
		        stageCounter++;
		        break;
		 //stage 2:erzeuge den Vertrag wenn Fuehrerschein ok
	     case 2:
	            String tmpVertragNr=zuKundenMietAngabe.fuehrerscheinNummerEingabe(FuehrerscheinCheck.isSelected());
	            if(tmpVertragNr != null)
	            {
	             MietvertragsnummerTextField.setText(tmpVertragNr);
	             MietvertragsnummerTextField.invalidate();
	             //here show a dialog box with the "mietvertrag"
	             //{{code here
	             (new GeneralDialog(this,"Vielen Dank")).setVisible(true);   
		         //}}
		         //{{zeige mietvertrag
		         (new MietvertragDialog(this,zuKundenMietAngabe.holeKundenMietvertrag(),zuKundenMietAngabe.gibtReservierungZurAusgabe())).setVisible(true);
		         //}}
		         setVisible(false);
		         zuKundenMietAngabe.killMietSystem();
		         }
	            else
	            {
	             (new GeneralDialog(this,"kein Fhrerschein")).setVisible(true);   
		         //last chance!!!
		         (new ConfirmDialog(this,"Fhrerschein wirklich nicht vorhanden")).setVisible(true);
		         if(this.holeDriverLic()) //ja kein Fhrerschein, Resevierung loeschen
		          {//sorry kein Fuehrerschein kein Auto
		           (new GeneralDialog(this,"Der Reservierungsvorgang wird abgebrochen")).setVisible(true);   
		           setVisible(false);
		           zuKundenMietAngabe.reservierungLoeschen();
		           zuKundenMietAngabe.killMietSystem();
		          }
		        }
	            break;
	    }
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == MietvertragGui.this)
				MietvertragGui_windowClosing(event);
		}
	}

	void MietvertragGui_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		MietvertragGui_windowClosing_Interaction1(event);
	}

	void MietvertragGui_windowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			this.setVisible(false);
		    dispose();
		} catch (java.lang.Exception e) {
		}
	}
}
