package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.border.BevelBorder;
import fahrzeug.*;
import kunde.*;
/**
 * Benutzerschnittstelle zur Eingabe von Kreditkarten oder
 * Firmenfahrer. Sie ist die Schnittstelle zur Reservierungssystem.
 * Reservierungscode wird hier gezeigt wenn alle Eingaben korrekt sind
 * 
 * @author Nathalie
 */

public class  ReservierungFrame extends javax.swing.JFrame
{
 
 public ReservierungFrame(ReservierungsSystem ResCoordinator)
 {
  this();
  ReservierungFuerCallback = ResCoordinator;   
  if(ReservierungFuerCallback.isFirmenKunde())
    {
     this.KundennummerTextField.setText(String.valueOf(ReservierungFuerCallback.holeFirmenKundennummer()));
     this.KreditkarteTextField.setEnabled(false);
     this.kreditkarteButton.setEnabled(false);
     }
  else
    {
     this.KundennummerTextField.setEnabled(false);
     this.FahrerTextField.setEnabled(false);
     this.CheckButton.setEnabled(false);
     this.KreditkarteTextField.setText(ReservierungFuerCallback.holeKreditKarten());
    }
 }
 
 public ReservierungFrame()
 {
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		getContentPane().setBackground(java.awt.Color.white);
		setSize(550,490);
		setVisible(false);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,420,550,40);
		WeiterButton.setText(">");
		WeiterButton.setActionCommand(">");
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(468,10,73,25);
		WeiterButton.setEnabled(false);
		WeiterzuMietButton.setText("Mietvertrag");
		WeiterzuMietButton.setActionCommand("Mietvertrag");
		NavPanel.add(WeiterzuMietButton);
		WeiterzuMietButton.setBounds(336,10,122,24);
		WeiterzuMietButton.setEnabled(false);
		//$$ FirmenBorder.move(24,456);
		//$$ FahrerFotoBorder.move(48,456);
		ReservierungsnummerPanel.setLayout(null);
		getContentPane().add(ReservierungsnummerPanel);
		ReservierungsnummerPanel.setBackground(new java.awt.Color(226,228,241));
		ReservierungsnummerPanel.setBounds(12,360,528,49);
		ReservierungsnummerPanel.add(ReservierungsTextPane);
		ReservierungsTextPane.setEditable(false);
		ReservierungsTextPane.setBounds(204,12,276,31);
		ReservierungsCodeLabel.setText("Reservierungsnummer");
		ReservierungsnummerPanel.add(ReservierungsCodeLabel);
		ReservierungsCodeLabel.setBounds(12,12,168,36);
		UeberpruefungPanel.setLayout(null);
		getContentPane().add(UeberpruefungPanel);
		UeberpruefungPanel.setBackground(new java.awt.Color(226,228,241));
		UeberpruefungPanel.setBounds(12,12,528,336);
		FirmenFahrerPanel.setBorder(FirmenBorder);
		FirmenFahrerPanel.setLayout(null);
		UeberpruefungPanel.add(FirmenFahrerPanel);
		FirmenFahrerPanel.setBackground(new java.awt.Color(226,228,241));
		FirmenFahrerPanel.setBounds(12,108,504,216);
		FirmenFahrerPanel.add(KundennummerTextField);
		KundennummerTextField.setBounds(120,24,192,23);
		FirmenFahrerPanel.add(FahrerTextField);
		FahrerTextField.setBounds(120,60,192,23);
		KundennummerLabel.setText("Kundennummer");
		FirmenFahrerPanel.add(KundennummerLabel);
		KundennummerLabel.setBounds(12,24,100,24);
		FahrerLabel.setText("Fahrername");
		FirmenFahrerPanel.add(FahrerLabel);
		FahrerLabel.setBounds(12,60,100,24);
		CheckButton.setText("berprfen");
		CheckButton.setActionCommand("berprfen");
		FirmenFahrerPanel.add(CheckButton);
		CheckButton.setBounds(216,96,97,24);
		FirmenFahrerPanel.add(ShowFotoLabel);
		ShowFotoLabel.setBackground(new java.awt.Color(226,228,241));
		ShowFotoLabel.setBounds(336,24,156,156);
		PrivatkundeKreditPanel.setBorder(PrivatBorder);
		PrivatkundeKreditPanel.setLayout(null);
		UeberpruefungPanel.add(PrivatkundeKreditPanel);
		PrivatkundeKreditPanel.setBackground(new java.awt.Color(226,228,241));
		PrivatkundeKreditPanel.setBounds(12,12,504,84);
		KreditkarteLabel.setText("Kreditkartennummer");
		PrivatkundeKreditPanel.add(KreditkarteLabel);
		KreditkarteLabel.setBounds(12,24,144,21);
		PrivatkundeKreditPanel.add(KreditkarteTextField);
		KreditkarteTextField.setBounds(168,24,228,24);
		kreditkarteButton.setText("berprfen");
		PrivatkundeKreditPanel.add(kreditkarteButton);
		kreditkarteButton.setBounds(288,52,108,24);
		//$$ bevelBorder1.move(48,366);
		//$$ titledBorder1.move(24,366);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
		kreditkarteButton.addActionListener(lSymAction);
		CheckButton.addActionListener(lSymAction);
		WeiterzuMietButton.addActionListener(lSymAction);
		//}}
	}
	//{{DECLARE_CONTROLS
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	javax.swing.JButton WeiterzuMietButton = new javax.swing.JButton();
	javax.swing.border.TitledBorder PrivatBorder = new javax.swing.border.TitledBorder("Privatkunden");
	javax.swing.border.TitledBorder FirmenBorder = new javax.swing.border.TitledBorder("Firmenkunden");
	//com.symantec.itools.javax.swing.borders.BevelBorder FahrerFotoBorder = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JPanel ReservierungsnummerPanel = new javax.swing.JPanel();
	javax.swing.JTextPane ReservierungsTextPane = new javax.swing.JTextPane();
	javax.swing.JLabel ReservierungsCodeLabel = new javax.swing.JLabel();
	javax.swing.JPanel UeberpruefungPanel = new javax.swing.JPanel();
	javax.swing.JPanel FirmenFahrerPanel = new javax.swing.JPanel();
	javax.swing.JTextField KundennummerTextField = new javax.swing.JTextField();
	javax.swing.JTextField FahrerTextField = new javax.swing.JTextField();
	javax.swing.JLabel KundennummerLabel = new javax.swing.JLabel();
	javax.swing.JLabel FahrerLabel = new javax.swing.JLabel();
	javax.swing.JButton CheckButton = new javax.swing.JButton();
	javax.swing.JLabel ShowFotoLabel = new javax.swing.JLabel();
	javax.swing.JPanel PrivatkundeKreditPanel = new javax.swing.JPanel();
	javax.swing.JLabel KreditkarteLabel = new javax.swing.JLabel();
	javax.swing.JTextField KreditkarteTextField = new javax.swing.JTextField();
	javax.swing.JButton kreditkarteButton = new javax.swing.JButton();
	//}}
	//{{DECLARE_MENUS
	//}}
	
	//{{DECLARE additional variables 
	ReservierungsSystem  ReservierungFuerCallback;
    //}}
    
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
			else if (object == kreditkarteButton)
				kreditkarteButton_actionPerformed(event);
			else if (object == CheckButton)
				CheckButton_actionPerformed(event);
			else if (object == WeiterzuMietButton)
				WeiterzuMietButton_actionPerformed(event);
		}
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	  //erzeugt und speichert die Reservierung
	  ReservierungFuerCallback.reservierungErzeugen();
	  WeiterzuMietButton.setEnabled(true);
	  WeiterButton.setEnabled(false);
	}

	void kreditkarteButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		kreditkarteButton_actionPerformed_Interaction1(event);
	}

	void kreditkarteButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		//{{rufe den Kreditkartenueberpruefungsmethod
		if(ReservierungFuerCallback.kreditKarteBehandlung(Integer.parseInt(KreditkarteTextField.getText())) != null)
	    {//Kreditkarte gltig , zeige Reservierungsnummer
	    ReservierungsTextPane.setText(ReservierungFuerCallback.holeReservierungsnummer());
	    ReservierungsTextPane.setEditable(false);
	    kreditkarteButton.setEnabled(false);
	    WeiterButton.setEnabled(true);
	    }
	}

	void CheckButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		CheckButton_actionPerformed_Interaction1(event);
	}

	void CheckButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		ReservierungFuerCallback.firmenKundenUeberpruefen(FahrerTextField.getText());
		if(!ReservierungFuerCallback.holeFahrerName().equals("none"))
		{
		ShowFotoLabel.setIcon(new ImageIcon(ReservierungFuerCallback.holeFahrerFotoLink()));
	    ReservierungsTextPane.setText(ReservierungFuerCallback.holeReservierungsnummer());
	    ReservierungsTextPane.setEditable(false);
	    WeiterButton.setEnabled(true);
	    CheckButton.setEnabled(false);
	    }
	}

	void WeiterzuMietButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		WeiterzuMietButton_actionPerformed_Interaction1(event);
	}

	void WeiterzuMietButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		ReservierungFuerCallback.startMietvertragSystem();
		this.setVisible(false);
		dispose();
	}
}
