package dvtautoio;

import java.io.*;
import java.util.*;

/**
 * Hier werden die grundstzliche Ein- und Ausgabefunktionen implementiert.
 * @author Shahriar 
 * 
 */
public class DVTAutoIO {
   public Object datenBloeckeEinlesen(Object _oObject) {
     Object outObject;

     outObject = new Object();
     String _sDateiName = new String(_oObject.getClass().getName().substring(_oObject.getClass().getName().indexOf('.')+1));
     System.out.println(_sDateiName);
     try{
        FileInputStream fisFileStream = new FileInputStream(_sDateiName);
        ObjectInputStream oisObjectStream = new ObjectInputStream(fisFileStream); 
        outObject = oisObjectStream.readObject(); 
        oisObjectStream.close(); 
     }catch(ClassNotFoundException e){
        System.err.println(e.toString());
     }catch(IOException e){
        System.err.println(e.toString());
        return null;
     }
     return ( outObject);
   }

   public Object datenBloeckeEinlesen(Object _oObject, String _sDateiName) {
     Object outObject;

     outObject = new Object();
     System.out.println(_sDateiName);
     try{
        FileInputStream fisFileStream = new FileInputStream(_sDateiName);
        ObjectInputStream oisObjectStream = new ObjectInputStream(fisFileStream); 
        outObject = oisObjectStream.readObject(); 
        oisObjectStream.close(); 
     }catch(ClassNotFoundException e){
        System.err.println(e.toString());
     }catch(IOException e){
        System.err.println(e.toString());
        return null;
     }
     return ( outObject);
   }

   
   public boolean datenBloeckeAusschreiben(Object _oObject) {
     String _sDateiName = new String(_oObject.getClass().getName().substring(_oObject.getClass().getName().indexOf('.')+1));
      System.out.println(_sDateiName);
     try{
        FileOutputStream fosFileStream = new FileOutputStream(_sDateiName);
        ObjectOutputStream oosObjectStream = new ObjectOutputStream(fosFileStream); 
        oosObjectStream.writeObject( _oObject); 
        oosObjectStream.close(); 
     }catch(IOException e){
        System.err.println(e.toString());
     }
     return (true);
   }

   public boolean datenBloeckeAusschreiben(Object _oObject, String _sDateiName) {
      System.out.println(_sDateiName);
     try{
        FileOutputStream fosFileStream = new FileOutputStream(_sDateiName);
        ObjectOutputStream oosObjectStream = new ObjectOutputStream(fosFileStream); 
        oosObjectStream.writeObject( _oObject); 
        oosObjectStream.close(); 
     }catch(IOException e){
        System.err.println(e.toString());
     }
     return (true);
   }
}



