package fahrzeug;

/**
 * Die Oberklasse aller Fahrzeugklassen.
 * @author Shahriar
 *
 */
public class Fahrzeug implements java.io.Serializable{
    protected String sAbbildung;
    protected int iWochenpreis;
    protected int iKilometerstand;
    protected int iNummernschild;
    protected float fTank;

    protected String sLaufenderVertrag;
    protected boolean bVerfuegbar;
    protected String sStandOrt;

    protected String sStandPlatz;
    protected int iFirmenRabatt = 20;

    protected String mietVertragNr;

   //Hier kommen die Methoden --------------------------------------------------
   //Initialisierung------------------------------------------------------------
   Fahrzeug(){
      //Initiallisierung einer leere Klasse
      sAbbildung=null;
      iWochenpreis=0;
      iKilometerstand=0;
      iNummernschild=0;
      fTank=0;
      mietVertragNr=null;
      bVerfuegbar=false;
      sStandOrt=null;
      sStandPlatz=null;
      iFirmenRabatt=0;
   }
   Fahrzeug( String _sAbbildung,
          int _iWochenpreis,
          int _iKilometerstand,
          int _iNummernschild,
          float _fTank,
          String  mietvertrag_nummer,
          boolean _bVerfuegbar,
          String _sStandOrt,
          String _sStandPlatz,
          int _iFirmenRabatt){
      sAbbildung=new String(_sAbbildung);
      iWochenpreis=_iWochenpreis;
      iKilometerstand=_iKilometerstand;
      iNummernschild=_iNummernschild;
      fTank=_fTank;
      mietVertragNr= new String(mietvertrag_nummer);
      bVerfuegbar=_bVerfuegbar;
      sStandOrt=new String(_sStandOrt);
      sStandPlatz=new String(_sStandPlatz);
      iFirmenRabatt=_iFirmenRabatt;
   }

   //Ende Initialisierung-------------------------------------------------------

    /**
     * Fahrzeug kann wieder reserviert und vermietet werden
     */
    public void fahrzeugFreigeben() {
      bVerfuegbar=true;
      mietVertragNr=null;
    }

    public void datenBlattAusgeben() {
    }

    //Hier die ganzen hole und setze Methoden--------------------------------------
    public void setzeImage(String _sImage){
      sAbbildung = new String(_sImage);
    }
    public String holeImage(){
      return(sAbbildung);
    }
    public void setzeWochenpreis(int _iWochenPreis){
      iWochenpreis = _iWochenPreis;
    }
    public int holeWochenpreis(){
      return(iWochenpreis);
    }
    public void setzeKilometerstand(int _iKilometerStand){
       iKilometerstand=_iKilometerStand;
    }
    public int holeKilometerstand(){
      return(iKilometerstand);
    }

    public int holeNummernschild(){
      return(iNummernschild);
    }

    public void setzeTank(float _fTank){
      fTank = _fTank ;
    }

    public float holeTank(){
      return(fTank);
    }

    public void setzeLaufenderVertrag(String  _sVertragsNummer){
      sLaufenderVertrag=new String (_sVertragsNummer);
    }
    public String holeLaufenderVertrag(){
      return(sLaufenderVertrag);
    }

    public void setzeVerfuegbar(boolean _bVerfuegbar){
      bVerfuegbar=_bVerfuegbar;
    }
    public boolean istVerfuegbar(){
      return(bVerfuegbar);
    }

    public void setzeStandort(String _sStandOrt){
      sStandOrt = new String(_sStandOrt);
    }
    public String holeStandort(){
      return(sStandOrt);
    }

    public void setzeStandplatz(String _sStandPlatz){
      sStandPlatz= new String(_sStandPlatz);
    }
    public String holeStandplatz(){
      return(sStandPlatz);
    }

    public void setzeFirmenrabatt(int _iFirmenRabatt){
      iFirmenRabatt=_iFirmenRabatt;
    }
    public int holeFirmenrabatt(){
      return(iFirmenRabatt);
    }
    public String holeMietVertragNr()
    {
     return mietVertragNr;
     }

    public void setzeMietVertragNr(String m)
    {
     mietVertragNr = new String(m);
    }
    //Ende der setze und hole Methoden---------------------------------------------

}
