package fahrzeug;

/**
 * Objekte dieser Klasse verknpfen ein angebotenes Fahrzeug mit dem Preis, der des
 * Interessenten zugeordnet ist
 * 
 * @author Nathalie
 */
public class MietpreisDesFahrzeugs implements java.io.Serializable {
    /**
     * @link aggregation 
     */
    private AngebotPreise lnkAngebotPreise;

    /**
     * @link aggregation 
     */
    private Fahrzeug lnkFahrzeug;
    
    public MietpreisDesFahrzeugs(AngebotPreise preis, Fahrzeug vehicle)
    {
     lnkAngebotPreise = preis;
     lnkFahrzeug = vehicle;
     }
     
     /**
      * @return Fahrzeug
      */
     public Fahrzeug holeLnkFahrzeug()
     {
        return lnkFahrzeug;
     }
     
     /**
      * @return AngebotPreise
      */
     public AngebotPreise holeLnkAngebotPreise()
     {
       return lnkAngebotPreise;  
     }
}
