package fahrzeug;


public class Mietvertrag implements java.io.Serializable{

    public Mietvertrag( String kunden_name,
                        String vertrags_nummer,
                        boolean fuehrerschein_vorgelegt,
                        Datum miet_beginn,
                        int nummern_schield,
                        String fahrzeug_standort,
                        int km_stand,
                        boolean is_firmenkunde,
                        int firmenkunden_nummer,
                        String fahrer_name,
                        String fahrzeug_katklasse
                      )
    {
        setzeKundenName(kunden_name);
        setzeVertragsNummer(vertrags_nummer);
        setzeFuehrerscheinVorgelegt(fuehrerschein_vorgelegt);
        setzeMietBeginn(miet_beginn);
        setzeNummernSchield(nummern_schield);
        setzeFahrzeugStandort(fahrzeug_standort);
        setzeKmStand(km_stand);
        setzeIsFirmenKunde(is_firmenkunde);
        if(is_firmenkunde)
        {
         setzeFirmenkundenNummer(firmenkunden_nummer);
         setzeFahrerName(fahrer_name);
        }
        setzeKategorieKlasse(fahrzeug_katklasse);

    }

    //{{public methods
    public void vertragsDetailsAnzeigen() {
    }

    public void vertragDrucken() {
    }
    //}}

    //{{properties
    private String kundenName;
    private String vertragsNummer;
    private boolean fuehrerscheinVorgelegt;
    private Datum mietBeginn;
    private int nummernSchield;
    private String fahrzeugStandort;
    private int KmStand;
    private String kategorieKlasse;
    //}}


      /** @link dependency */
    private boolean isFirmenKunde;
    private int firmenkundenNummer;
    private String fahrerName;


    //{{accessor methods
    public String holeKundenName()
    {
     return kundenName;
    }

    public void setzeKundenName(String kndname)
    {
     kundenName = new String(kndname);
    }

    public String holeVertragsNummer()
    {
      return vertragsNummer;
    }

    public void setzeVertragsNummer(String vrtgnummer)
    {
      vertragsNummer = new String(vrtgnummer);
    }

    public boolean isFuehrerscheinVorgelegt()
    {
      return  fuehrerscheinVorgelegt;
    }

    public void setzeFuehrerscheinVorgelegt(boolean fuehrerschein_da)
    {
     fuehrerscheinVorgelegt  = fuehrerschein_da;
    }

    public Datum holeMietBeginn()
    {
      return mietBeginn;
    }

    public void setzeMietBeginn(Datum miet_bgn)
    {
     mietBeginn = miet_bgn;
    }

    public int holeNummernSchield()
    {
     return  nummernSchield;
    }

    public void setzeNummernSchield(int nmr_schield)
    {
      nummernSchield = nmr_schield;
    }

    public String holeFahrzeugStandort()
    {
     return fahrzeugStandort;
    }

    public void setzeFahrzeugStandort(String stand_ort)
    {
      fahrzeugStandort = new String(stand_ort);
    }

    public int holeKmStand()
    {
     return KmStand;
    }

    public void setzeKmStand(int km_std)
    {
     KmStand = km_std;
    }


    public boolean IsisFirmenKunde()
    {
     return isFirmenKunde;
     }

    public void setzeIsFirmenKunde(boolean firmen_knd)
    {
     isFirmenKunde = firmen_knd;
     }

    public int holeFirmenkundenNummer()
    {
      return   firmenkundenNummer;
    }

    public void setzeFirmenkundenNummer(int knd_nmr)
    {
       firmenkundenNummer = knd_nmr;
     }

    public String holeFahrerName()
    {
        return fahrerName;
    }

    public void setzeFahrerName(String fhr_name)
    {
      fahrerName = new String(fhr_name);
    }

    public String holeKategorieKlasse()
    {
     return kategorieKlasse;
    }

    public void setzeKategorieKlasse(String kktkls)
    {
      kategorieKlasse = new String(kktkls);
    }


    //}}
}
