package fahrzeug;
import java.util.Vector;
/**
 * Liste aus allen vorhandenen Reservierungen
 * 
 * @author Nathalie
 */


public class Reservierungen extends kunde.Liste{

    
    //{{public methods
    
    public Reservierung eintraegeAuflisten(String reservierung_nummer)
    {
     for(int i=0; i < this.size(); i++)
     {
      Reservierung tmpReservierung = (Reservierung)this.elementAt(i);
      if( (tmpReservierung.holeReservierungsnummer()).equals(reservierung_nummer))   
        {
         return tmpReservierung;
        }
     }
      return null;  //Reservierungseintrag nicht gefunden
    }

    
    public Reservierung eintraegeAuflistenKunden(String privat_kundenname)
    {
     for(int i=0; i < this.size(); i++)
     {
      Reservierung tmpReservierung = (Reservierung)this.elementAt(i);
      if( (tmpReservierung.holeReservierungsnummer()).equals(privat_kundenname))   
        {
         return tmpReservierung;
        }
     }
      return null;  //Reservierungseintrag nicht gefunden
    }

    
    
    public boolean eintragLoeschen(String reservierungsnummer) 
    {
     for(int i=0; i < this.size(); i++)
     {
      if(((Reservierung)this.elementAt(i)).holeReservierungsnummer().equals(reservierungsnummer))   
        {
          this.removeElementAt(i);
          return true;
        }
     }
     return false; //Eintrag nicht gefunden
    }

    
    public void neuerEintrag(Reservierung neuereservierung)
    {
     this.addElement(neuereservierung);
    }

    //}}
    /**
     * @link aggregation
     * @clientCardinality 1
     * @supplierCardinality 0..* 
     */

    /** @link dependency */
    /*#ReservierungsSystem lnkReservierungsSystem;*/
    public void neuerEintrag(Object _oObject){};

    public boolean eintragLoeschen(Object _oObject){return true;};

    public Vector eintraegeAuflisten(){return new Vector();};


}
