package fahrzeug; 

import kunde.*;
import dvtautoio.*;
import Gui.*;
import java.io.*;
import java.util.Vector;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import Starter;
/**
 * Bearbeitet Reservierung. Aus dieser Klasse werden die Klassen zur Angeboterstellung und
 * Mietvertragvorbereitung aufgerufen. berprfung der Kundendaten wird hier auch behandelt.
 * 
 * @author Nathalie
 */


public class ReservierungsSystem extends javax.swing.JFrame implements AngebotWeiterLeitenAnReservierung,KundenInfoAnReservierung{
    
    public ReservierungsSystem()
    {
        setSize(200,100);
        setVisible(false);
      //hole den serialisierte counter des Reservierungsnummers
      //hole den serialisierte ReservierungennObjekt
      //{{code here
      
      try{
       java.io.ObjectInputStream i = new java.io.ObjectInputStream(new FileInputStream("rcounter.out"));
       ReservierungsnummerCounter = (String)i.readObject();
       }
       catch(java.io.IOException iofehler){}
       catch(java.lang.ClassNotFoundException cnot){}
      
      DVTAutoIO rsrOeffner = new DVTAutoIO();
      vorhandeneReservierungen = (Reservierungen) rsrOeffner.datenBloeckeEinlesen(new Reservierungen());
      //}}
      //}}
      angebotErstellen() ;
    }
    
    
        
    //{{***************MAIN*********************
    
    static public void main(String args[])
    {
     try{   
        new ReservierungsSystem();
     } 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
         
    }
    //}}****************************************
    
    
    public void neueKundenErfassen() 
    {
     //startet die Kundenerfassung fuer Privatkunde
     (new PrivatKundeEingabe(this)).setVisible(true);
     }

    public String kreditKarteBehandlung(int kundenkreditkarte)
    {
     //eingabe des Kreditkartennummer
     if((kundenkreditkarte > 500) && (kundenkreditkarte < 600))
       { 
        setzePrivatkundeKreditkarte(kundenkreditkarte);
        return reservierungsNummerAusgabe() ; //Kreditkarte in Ordnung erzeugt Reservierungsnummer bei PRivatkunde
       }
     else
       {
        setzePrivatkundeKreditkarte(0); //Kreditkarte ungueltig
        //zeige Dialog Box -> Kreditkarte abgelehnt
        //{{erwarte neue Kreditkartenummereingabe
         (new GeneralDialog(this,"Kreditkarte ungltig")).setVisible(true);
         return null;  
        //}}
       }
    }

    public void fahrzeugBestimmen() 
    {//fahrzeug aus AngebotListe holen
     setzeDvtautoAngebot((kundenAutoInfoSammler.holeErzeugteAngebot()).holeGewaehltesFahrzeug());
     //bei Firmenkunde glaich die Kundennummer mituebernehmen
     setzeFirmenKunde(kundenAutoInfoSammler.isFirmenKunde());
     if(isFirmenKunde())
       FirmenKundennummer = kundenAutoInfoSammler.holeFirmenkundenNummer();
     //Miettermine festhalten
     mietStartEnde = new MietTermin(kundenAutoInfoSammler.holeMietStart(),kundenAutoInfoSammler.holeMietEnde());
    }

    public void angebotErstellen() 
    {//Angebotsystem aufrufen
     kundenAutoInfoSammler = new Kundenanfrage(this);
    }

    public void firmenKundenUeberpruefen(String fahrerName)
    {//Firmenfahrer ueberpruefen
     //Firmenkundenliste oeffnen, Kundennummer ueberpruefen und Fahrerliste holen
     //Fahrer name ueberpruefen, Bild holen und zeigen
     //firmenkundeliste oeffnen und firmenkundenummer benutzen um kunde zu finden
     DVTAutoIO kundenOeffner = new DVTAutoIO();
     FirmenKundenListe allFirmenkunde = (FirmenKundenListe)kundenOeffner.datenBloeckeEinlesen(new FirmenKundenListe());
     FirmenKunde tempFirmenKunde = null;
     tempFirmenKunde = allFirmenkunde.firmenKundeNachNummerSuchen(holeFirmenKundennummer()); 
     if(tempFirmenKunde!= null)
       {
        setzeKundenName(tempFirmenKunde.holeName());
        //ueberpruefe Fahrer
        Vector tempFahrer = tempFirmenKunde.holeLnkFirmenmitglieder();
        int m=0;
        for(m=0; m < tempFahrer.size(); m++)
        {
         String tmpname = ((FirmenMitglieder)(tempFahrer.elementAt(m))).holeName();
         if(tmpname.equals(fahrerName))   
           {
            setzeFahrerName(tmpname);
            setzeFahrerFotoLink(((FirmenMitglieder)tempFahrer.elementAt(m)).holeBildDatei());
            reservierungsNummerAusgabe() ;
            break; //Fahrer gefunden raus aus der Schleife
           }
        }
         //Fahrer nicht gefunden -> FahrerName bleibt "none"
         //zeige Dialog Box , breche ab, exit
         if(m == tempFahrer.size())
          {
          (new GeneralDialog(this,"Firmenfahrer nicht gefunfen")).setVisible(true);
            this.dispose();
          }
        }
       else
       {
        //Firmenkundennummer ungueltigt
        //zeige Dialog box, breche ab, exit
        (new GeneralDialog(this,"Firmennummer nicht gltig")).setVisible(true);
          this.dispose();
          
       }
     
    }

    public void reservierungErzeugen()
    {//diese methode aufrufen nachdem der Kunde bestaetigt hat
     //die neue ReservierungsnummerCounter abspeichern
     //{{code here
      try{
        java.io.ObjectOutputStream o = new java.io.ObjectOutputStream(new FileOutputStream("rcounter.out"));
        o.writeObject(ReservierungsnummerCounter);
        o.close();}
        catch(java.io.IOException ioweg){}
     //}}     
     //Reservierungsobjekt erzeugen, in die Reservierungen eintragen, abspeichern
     Reservierung tempReservierung = new Reservierung(FirmenKundennummer,
                          dvtautoAngebot,
                          KundenName,
                          Reservierungsnummer,
                          PrivatkundeKreditkarte,
                          mietStartEnde,
                          FirmenKunde,
                          FahrerName);
     vorhandeneReservierungen.neuerEintrag(tempReservierung);
     //Liste serialisieren und abspeichern 
     //{{code here
     DVTAutoIO rsrOut = new DVTAutoIO();
     rsrOut.datenBloeckeAusschreiben(vorhandeneReservierungen);
     //}}
    
     //{{Fahrzeug als nicht verfgbar kennzeichnen
      DVTAutoIO fahrzeugOeffner = new DVTAutoIO();
      Fahrzeug tmpSelectedAuto = dvtautoAngebot.holeLnkFahrzeug();
      tmpSelectedAuto.setzeVerfuegbar(false);
      System.out.println("Auto zum reservieren:"+ tmpSelectedAuto.getClass().getName());
      FahrzeugBestand tmpListe = (FahrzeugBestand)fahrzeugOeffner.datenBloeckeEinlesen(tmpSelectedAuto);
      tmpListe.FahrzeugLoeschen(tmpSelectedAuto.holeNummernschild());
      tmpListe.neuerEintrag(tmpSelectedAuto);
      String tmpName = tmpSelectedAuto.getClass().getName();
      tmpName = tmpName.substring(tmpName.indexOf('.')+1);
      fahrzeugOeffner.datenBloeckeAusschreiben(tmpListe,tmpName);
      //}}
    }

    public String reservierungsNummerAusgabe() 
    {//Reservierungsnummer erzeugen, ReservierungsnummerCounter incrementieren
      String fahrzeugKlasseKat = (dvtautoAngebot.holeLnkFahrzeug()).toString();
      int startPosition = fahrzeugKlasseKat.indexOf(".");
      int endPosition = fahrzeugKlasseKat.indexOf("@");
      fahrzeugKlasseKat = fahrzeugKlasseKat.substring(startPosition+1,endPosition);
      //Einordnen der Fahrzeugeklassen um Reservierungsnummer zu erzeugen
      if(fahrzeugKlasseKat.equals("PickUp"))
        Reservierungsnummer = "U-"+ ReservierungsnummerCounter;
      else
        if(fahrzeugKlasseKat.equals("KompaktKlasse"))
          Reservierungsnummer = "PK"+ ReservierungsnummerCounter;
        else
          if(fahrzeugKlasseKat.equals("MittelKlasse"))
            Reservierungsnummer = "PM"+ ReservierungsnummerCounter;
          else
            if(fahrzeugKlasseKat.equals("OberKlasse"))
               Reservierungsnummer = "PO"+ ReservierungsnummerCounter;
            else
              if(fahrzeugKlasseKat.equals("Van"))
                Reservierungsnummer = "PV"+ ReservierungsnummerCounter;
               else
                 if(fahrzeugKlasseKat.equals("Ueber2_8Tonnen"))
                     Reservierungsnummer = "LG"+ ReservierungsnummerCounter;
                  else
                     Reservierungsnummer = "L-"+ ReservierungsnummerCounter;//Klein laster bis 2.8 tonnen                                   
      //Counter incrementieren
      ReservierungsnummerCounter = String.valueOf((Integer.parseInt(ReservierungsnummerCounter))+1);
      return Reservierungsnummer;
    }

    //startet den Mietvertrag erzeuger
    public void startMietvertragSystem()
    {
     new KundenAngaben(Reservierungsnummer,this);   
    }
    
    //Beendet Reservierungssystem
    public void killReservierung()
    {
      dispose();
      
    }
    
    
   //{{properties
   MietpreisDesFahrzeugs dvtautoAngebot; //Angebotliste erzeugt von Kundenanfrage
   Kundenanfrage kundenAutoInfoSammler; //holder der Klasse KundenAnfrage
   boolean FirmenKunde=false;
   int FirmenKundennummer=0;
   int PrivatkundeKreditkarte =0;
   String FahrerName = new String("none");
   String ReservierungsnummerCounter = String.valueOf(0);
   String KundenName=new String();
   String FahrerFotoLink = new String("none"); //name der Datei des Fahrerbildes
   String Reservierungsnummer = new String();
   Reservierungen vorhandeneReservierungen;
   MietTermin mietStartEnde;
   String KreditKarten= new String();
   //}}
   
   //{{accessor methods
   public void setzeDvtautoAngebot(MietpreisDesFahrzeugs fzgdetail)
   {
    dvtautoAngebot = fzgdetail;
   }
   
   public MietpreisDesFahrzeugs holeDvtautoAngebot()
   {
    return dvtautoAngebot;
   }
   
   public boolean isFirmenKunde()
   {
    return FirmenKunde;
   }
   
   public void setzeFirmenKunde(boolean jaFirmen)
   {
    FirmenKunde = jaFirmen; 
   }
   
   public void setzeFirmenKundennummer(int Fnumm)
   {
    FirmenKundennummer = Fnumm;
   }
   
   public int holeFirmenKundennummer()
   {
    return FirmenKundennummer; 
   }
   
   public int holePrivatkundeKreditkarte()
   {
    return PrivatkundeKreditkarte;
   }
   
   public void setzePrivatkundeKreditkarte(int visamasteramex)
   {
     PrivatkundeKreditkarte = visamasteramex;
     if(PrivatkundeKreditkarte != 0)
        {//Kreditkarte gueltig
        PrivatKunde prvtKunde = Starter.pklPrivatKundenListe.kundeSuchen(this.holeKundenName());
        Starter.pklPrivatKundenListe.remove(prvtKunde);
        prvtKunde.setzeKreditkarte(String.valueOf(PrivatkundeKreditkarte));
        Starter.pklPrivatKundenListe.addElement(prvtKunde);
        }
   }
   
   public String holeFahrerName()
   {
    return FahrerName;
   }
   
   public void setzeFahrerName(String fahrer)
   {
     FahrerName = fahrer;
    }
    
    public String holeKundenName()
    {
     return KundenName;
    }
    
    public void setzeKundenName(String kunde)
    {
     KundenName = new String(kunde);   
     }
     
     public void setzeFahrerFotoLink(String imgname)
     {
      FahrerFotoLink = new String(imgname);  
      }
      
     public String holeFahrerFotoLink()
     {
       return FahrerFotoLink;   
     }
     
     public String holeReservierungsnummer()
     {
      return Reservierungsnummer;
     }
   
    public String holeKreditKarten()
    {
     return KreditKarten;   
    }
    
    public void setzeKreditKarten(String krtNr)
    {
     KreditKarten = krtNr; 
    }
   //}}
   
   //{{interface AngebotWeiterLeitenAnReservierung implemetieren
   public void angebotUebergabeAnReservierung()
   {//das gewaehltes Fahrzeug holen in Reservierungssystem behalten
    fahrzeugBestimmen(); 
    //wenn privatkunde -> neueKundenErfassen() dann kreditKarteBehandlung else firmenKundenUeberpruefen
    if(!isFirmenKunde())
      neueKundenErfassen(); //Privatkundenerfassung starten
    else
      (new ReservierungFrame(this)).setVisible(true);  //startet den ReservierungsGUI und erwarte Firmenkundenummer- und Fahrereingabe
    }
   //}}
   
   //{{interface KundenInfoAnReservierung implementieren
   public void privatKundeInfoLiefern(Object o)
   {
      PrivatKunde tmpKunde = (PrivatKunde)o;
      this.setzeKundenName(tmpKunde.holeName());
      this.setzeKreditKarten(tmpKunde.holeKreditkarte());
      String fahrzeugKlasseKat = (dvtautoAngebot.holeLnkFahrzeug()).toString();
      int startPosition = fahrzeugKlasseKat.indexOf(".");
      int endPosition =  fahrzeugKlasseKat.indexOf("@");
      fahrzeugKlasseKat = fahrzeugKlasseKat.substring(startPosition+1,endPosition);
      if(fahrzeugKlasseKat.equals("Ueber2_8Tonnen"))
        {
         if(tmpKunde.holeAlter() < 24)
          {
          //zu jung, breche ab
          (new GeneralDialog(this,"Fahrer ist zu jung fr ein Laster mit ber 2,8 Tonnen Kapazitt")).setVisible(true);
          killReservierung();
          return;
          }
        }
      else
       if(fahrzeugKlasseKat.equals("bis2_8Tonnen"))
        {
         if(tmpKunde.holeAlter() < 21)
         {
          //zu jung, breche ab   
          (new GeneralDialog(this,"Fahrer ist zu jung fr ein Laster mit unter 2,8 Tonnen Kapazitt")).setVisible(true);
          killReservierung();
          return;
          }
         }
        else
         {
          if(tmpKunde.holeAlter() < 18)
         {
          //zu jung, breche ab   
          (new GeneralDialog(this,"Fahrer ist zu jung um Fhrerschein zu besitzen")).setVisible(true);
          killReservierung();
          return;
          }
         }
     (new ReservierungFrame(this)).setVisible(true); //startet ReservierungsGUI und erwarte Kreditkarteneingabe
   };  
   //}}
}
