package kunde;

import java.util.Vector;
import fahrzeug.ReservierungsSystem;
import dvtautoio.DVTAutoIO;

/**
 * Dies ist die sortierte Privatkundenliste
 * @author Shahriar 
 * 
 */

 public class PrivatKundenListe extends ListeNachNamenSortiert {

    public int privatKundenListenPositionLiefern(String _sName){
       int iAnfang=0, iEnde, i=iAnfang;

        iEnde = (this.size()-1);

        while((i != iEnde) && !(_sName.equalsIgnoreCase(((PrivatKunde) this.elementAt(i)).sName)))i++;
        if (true == (_sName.equalsIgnoreCase(((PrivatKunde) this.elementAt(i)).sName))){
            return (i);
        }else return (-1);
    }
 
    public boolean neuenKundenEintragen(Object _oKunde) {
        Vector v;
        v = new Vector();
        //Schaut nach, ob der Kunde schon eingetragen ist
        v = privatkundenAuflisten(((PrivatKunde) _oKunde).sName);
        //wenn nicht, neue Eintrag
        if (
            (v.isEmpty())&&
            (((PrivatKunde) _oKunde).iAlter > 21 )&&   //Alter ueber 21?
            ((((PrivatKunde) _oKunde).sAusweisnummer.length()) != 0)  //Ausweis vorgezeigt?
            ){
            neuerEintrag(_oKunde);
            //privatKundeInfoLiefern(_oKunde);
            return (true);
        }else return(false);      //wenn doch abbruch
    }

    public void kundenDatenLoeschen(String _sName) {
      this.eintragLoeschen(kundeSuchen(_sName));
    }

    public Vector privatkundenAuflisten(String _sName) {
         int iAnfang=0, iEnde, i=iAnfang;
         Vector v;
         iEnde = (this.size()-1);
         v = new Vector();

         if(iEnde == -1)
           return v;  // list is empty -> out
           
         while(i != iEnde){
            if ( _sName.equalsIgnoreCase(((Kunde) this.elementAt(i)).sName)){
               v.addElement(this.elementAt(i));   
            }
            i++;
         }
         return (v);
          
     }

    public PrivatKunde kundeSuchen(String _sName) {
        int iAnfang=0, iEnde, i=iAnfang;

        iEnde = (this.size()-1);

        while((i != iEnde) && !(_sName.equalsIgnoreCase(((PrivatKunde) this.elementAt(i)).sName)))i++;
        if ((_sName.equalsIgnoreCase(((PrivatKunde) this.elementAt(i)).sName)) == true)return ((PrivatKunde)this.elementAt(i));
        return null;
    }

    public static void ausgabe1DFeld (int[] iPLZ){
      DVTAutoIO ioStream;
      PrivatKundenListe pklLocalPrivatKundenListe;
      int[] plzListe;
      Vector v;
      int iAnfang=0, iEnde, i=iAnfang;
      
      v = new Vector();
      pklLocalPrivatKundenListe = new PrivatKundenListe();
      ioStream = new DVTAutoIO();   
      pklLocalPrivatKundenListe =  (PrivatKundenListe)ioStream.datenBloeckeEinlesen(pklLocalPrivatKundenListe);
      iEnde = (pklLocalPrivatKundenListe.size()-1);
      
      if(iEnde == -1){
         iPLZ = null;  // list is empty -> out
         return;
      }
         
      while(i != iEnde){
          v.addElement(new Integer(((PrivatKunde)pklLocalPrivatKundenListe.elementAt(i+1)).holeAdresse().holePLZ()));   
          i++;
      }
      for(i=0;i<iEnde;i++){
         iPLZ[i] = ((Integer)(v.elementAt(i))).intValue() ;
      }
    }
    /**
     * @label
     * @link aggregation
     * @undirected
     * @clientCardinality 1
     * @supplierCardinality 0..*
     * @clientRole
     * @supplierRole
     * @clientQualifier
     * @supplierQualifier 
     */
    private PrivatKunde lnkPrivatkunde;
}

